-- -------------------------------------------------------------------------- --
-- SpellTracker By Xulos ( EU ALLIANCE YSONDRE )      
-- -------------------------------------------------------------------------- --
UIPanelWindows["SpellTrackerFrame"] = { area = "doublewide", pushable = 0, width = 200, xoffset = 80, whileDead = 1 };

SpellTracker = {};
SpellTracker.Version = GetAddOnMetadata("SpellTracker", "Version");
SpellTracker.BARS = {}; -- stock les abbres qui sont cr au dbut et sont dans le cache
SpellTracker.SpellListToSort = {}; -- litse ordonne des barres a afficher
SpellTracker.ScrollValue = 0; -- valeur de la scrolbar virtuelle
SpellTracker.CountBarToDisplay = 0;
SpellTracker.CountBarDisplayed = 0;
SpellTracker.FilterBtnDown = false;
SpellTracker.MinimapBtnDown = false;
SpellTracker.EventPerSec_LastTickTime = 0;
SpellTracker.EventPerSec_Ticks = 0;
SpellTracker.RaidLst = {}; -- raid tracking ( included raid palyer and raid pet )
SpellTracker.PartyLst = {}; -- grou tracking ( included party player and party pet )
SpellTracker.CombatFlags = {
	[0x00004000]="TYPE_OBJECT",
	[0x00002000]="TYPE_GUARDIAN",
	[0x00001000]="TYPE_PET",
	[0x00000800]="TYPE_NPC",
	[0x00000400]="TYPE_PLAYER",
	[0x00000200]="CONTROL_NPC",
	[0x00000100]="CONTROL_PLAYER",
	[0x00000040]="REACTION_HOSTILE",
	[0x00000020]="REACTION_NEUTRAL",
	[0x00000010]="REACTION_FRIENDLY",
	[0x00000008]="AFFILIATION_OUTSIDER",
	[0x00000004]="AFFILIATION_RAID",
	[0x00000002]="AFFILIATION_PARTY",
	[0x00000001]="AFFILIATION_MINE",
};

-- Fonctions statiques GUI lies au XML
function SpellTrackerFrame_Init(self)
	local WellLoaded = false;
	
	SpellTrackerDB = SpellTrackerDB or {};

	if ( SpellTrackerDB.Version ) then
		if ( SpellTrackerDB.Version ~= SpellTracker.Version ) then
			SpellTrackerDB = {};
			SpellTrackerDB.Version = SpellTracker.Version;
		end
	else
		SpellTrackerDB = {};
		SpellTrackerDB.Version = SpellTracker.Version;
	end
	
	SpellTrackerDB.Record = SpellTrackerDB.Record or {}; -- les record ( valeur la plus garnd atteinte )
	SpellTrackerDB.SPELLS = SpellTrackerDB.SPELLS or {}; -- stock les infos a afficher
	SpellTrackerDB.FILTEREDSPELLS = SpellTrackerDB.FILTEREDSPELLS or {}; -- version filtrs en fonction justement des filtres
	SpellTrackerDB.FILTEREDSPELLS.count = 0;
	
	SpellTrackerDB.Params = SpellTrackerDB.Params or {};
	SpellTrackerDB.Params.SpellBarHeight = SpellTrackerDB.Params.SpellBarHeight or 20;
	SpellTrackerDB.Params.FrameWidth = SpellTrackerDB.Params.FrameWidth or 600;
	SpellTrackerDB.Params.FrameHeight = SpellTrackerDB.Params.FrameHeight or 600;
	
	-- faudra trouver une formule pour calculer automatiquement la valeur selon le nombre de barres totales a afficher et le nombre de barres qu'on peut afficher
	-- en fait le mieux est jutse de tenir compte d'un ratio du nombre de barres qu'on peut afficher
	SpellTrackerDB.Params.SrollStep = 1; -- en nombres de barres
	
	-- seuil en seconde au de la duquel l'indicateur de Ev/s est reset
	SpellTrackerDB.Params.EventPerSec_SeuilInSecBeforeReset = 5;
	
	-- indique les items possible pour la structure de donne / 0.41
	SpellTrackerDB.Params.DataStructItems = SpellTrackerDB.Params.DataStructItems or 
	{
		[0]="SpellName", -- permet de pas tre embt avec un sort en 8... et son tick en 10... ( ce serait bien de faire le distinguo..; => a voir )
		[1]="HitType", -- le meme sort peux faire du heal et du dgat
		[2]="SourceType", -- Mob / Player / Pet / Vehicle
		[3]="SourceReaction", -- raction de la source par rapport a mon perso
		[4]="SourceName", -- Name
		[5]="TargetType", -- Mob / Player / Pet / Vehicle
		[6]="TargetReaction", -- raction de la cible par rapport a mon perso
		[7]="TargetName" -- Name
	};
	
	-- menus
	SpellTrackerDB.MenuDropDown_Target = SpellTrackerDB.MenuDropDown_Target or {}
	SpellTrackerDB.MenuDropDown_Target.It1 = SpellTrackerDB.MenuDropDown_Target.It1 or {};
	SpellTrackerDB.MenuDropDown_Target.It1.txt = "My Player Tracking";
	if ( SpellTrackerDB.MenuDropDown_Target.It1.check == nil ) then SpellTrackerDB.MenuDropDown_Target.It1.check = true; end
	
	SpellTrackerDB.MenuDropDown_Target.It2 = SpellTrackerDB.MenuDropDown_Target.It2 or {};
	SpellTrackerDB.MenuDropDown_Target.It2.txt = "Selected Player Tracking";
	if ( SpellTrackerDB.MenuDropDown_Target.It2.check == nil ) then SpellTrackerDB.MenuDropDown_Target.It2.check = true; end
	
	SpellTrackerDB.MenuDropDown_Target.It3 = SpellTrackerDB.MenuDropDown_Target.It3 or {};
	SpellTrackerDB.MenuDropDown_Target.It3.txt = "Zone Tracking";
	if ( SpellTrackerDB.MenuDropDown_Target.It3.check == nil ) then SpellTrackerDB.MenuDropDown_Target.It3.check = true; end
	
	SpellTrackerDB.MenuDropDown_Target.It4 = SpellTrackerDB.MenuDropDown_Target.It4 or {};
	SpellTrackerDB.MenuDropDown_Target.It4.txt = "Raid Zone Tracking";
	if ( SpellTrackerDB.MenuDropDown_Target.It4.check == nil ) then SpellTrackerDB.MenuDropDown_Target.It4.check = true; end
	
	SpellTrackerDB.MenuDropDown_Target.It5 = SpellTrackerDB.MenuDropDown_Target.It5 or {};
	SpellTrackerDB.MenuDropDown_Target.It5.txt = "Group Zone Tracking";
	if ( SpellTrackerDB.MenuDropDown_Target.It5.check == nil ) then SpellTrackerDB.MenuDropDown_Target.It5.check = true; end
	
	SpellTrackerDB.MenuDropDown_SRC_OR_DST = SpellTrackerDB.MenuDropDown_SRC_OR_DST or {}
	
	SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1 = SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1 or {};
	SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.txt = "Emitted";
	if ( SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.check == nil ) then SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.check = true; end
	
	SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2 = SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2 or {};
	SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.txt = "Received";
	if ( SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.check == nil ) then SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.check = false; end
	
	-- dropdown -- on charge ici car sinonca genere une erreur vu que la frame est initialise avant la creation de SpellTrackerDB
	UIDropDownMenu_Initialize(SpellTracker_MyDropDownMenu, SpellTracker_MyDropDownMenu_OnLoad, "MENU");
	SpellTrackerFrameMainMenuTitleOtherTarget:SetScript("OnClick", 
		function()	
			ToggleDropDownMenu(1, nil, SpellTracker_MyDropDownMenu, SpellTrackerFrameMainMenuTitleOtherTarget, 0, 0);
		end
	);
	
	UIDropDownMenu_Initialize(SpellTracker_MyDropDownMenu2, SpellTracker_MyDropDownMenu2_OnLoad, "MENU");
	SpellTrackerFrameMainMenuTitleAttackORAttacked:SetScript("OnClick", 
		function()	
			ToggleDropDownMenu(1, nil, SpellTracker_MyDropDownMenu2, SpellTrackerFrameMainMenuTitleAttackORAttacked, 0, 0);
		end
	);
	
	--Color => ce qui suit vien du fichier bli constant.lua
	--NORMAL_FONT_COLOR           = {r=1.0, g=0.82, b=0.0};
	--HIGHLIGHT_FONT_COLOR        = {r=1.0, g=1.0, b=1.0};
	--RED_FONT_COLOR              = {r=1.0, g=0.1, b=0.1};
	--DIM_RED_FONT_COLOR          = {r=0.8, g=0.1, b=0.1};
	--GREEN_FONT_COLOR            = {r=0.1, g=1.0, b=0.1};
	--GRAY_FONT_COLOR             = {r=0.5, g=0.5, b=0.5};
	--YELLOW_FONT_COLOR           = {r=1.0, g=1.0, b=0.0};
	--LIGHTYELLOW_FONT_COLOR      = {r=1.0, g=1.0, b=0.6};
	--ORANGE_FONT_COLOR           = {r=1.0, g=0.5, b=0.25};
	--PASSIVE_SPELL_FONT_COLOR    = {r=0.77, g=0.64, b=0.0};
	--BATTLENET_FONT_COLOR        = {r=0.510, g=0.773, b=1.0};
	SpellTrackerDB.Params.DefaultColor = SpellTrackerBar_GetColorCodeFromRGBStruct(NORMAL_FONT_COLOR);
	SpellTrackerDB.Params.FriendlyColor = SpellTrackerBar_GetColorCodeFromRGBStruct(GREEN_FONT_COLOR);
	SpellTrackerDB.Params.HostileColor = SpellTrackerBar_GetColorCodeFromRGBStruct(RED_FONT_COLOR);
	
	-- par default => SpellTrackerDB.Params.DefaultCountSpellsToTrack = 50; -- pilote le nombre de barres qui vont tre cres  l'avance
	-- un raid sur orgri ca fait 200 barres
	--SpellTrackerDB.Params.DefaultCountSpellsToTrack = 200; -- pilote le nombre de barres qui vont tre cres  l'avance
	
	SpellTrackerDB.SPELLSTOTTRACK = SpellTrackerDB.SPELLSTOTTRACK or {}; -- stock les sort  traquer
	
	SpellTrackerDB.CurrentPlayerTracked = SpellTrackerDB.CurrentPlayerTracked or {};
	if ( SpellTrackerDB.MenuDropDown_Target.It3.check == false ) then -- zone tracking c'est les 3 membre == nil ce qui est fausus par l'affectation + init de base truc = truc or machin
		SpellTrackerDB.CurrentPlayerTracked.GUID = SpellTrackerDB.CurrentPlayerTracked.GUID or UnitGUID("player");
		SpellTrackerDB.CurrentPlayerTracked.Name = SpellTrackerDB.CurrentPlayerTracked.Name or UnitName("player");
		SpellTrackerDB.CurrentPlayerTracked.lvl = SpellTrackerDB.CurrentPlayerTracked.lvl or UnitLevel("player");
	end
	SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked or true;
	SpellTrackerDB.MsgToolTip = SpellTrackerDB.MsgToolTip or "Track Source";
	
	WellLoaded = SpellTracker:InitDataStruct("SpellName>HitType>SourceType>SourceReaction>SourceName>TargetType>TargetReaction>TargetName");
	WellLoaded = SpellTracker:InitDisplayedFilter("SpellName+HitType+SourceType+SourceReaction+SourceName+TargetType+TargetReaction+TargetName");
	
	-- record de ev/s
	SpellTrackerDB.Record.MaxEventPerSecValue = SpellTrackerDB.Record.MaxEventPerSecValue or 0;
	
	SpellTrackerDB.currentSessionHealTotal = SpellTrackerDB.currentSessionHealTotal or 0;
	SpellTrackerDB.currentSessionDamageTotal = SpellTrackerDB.currentSessionDamageTotal or 0;
	
	SpellTracker:AdjustColorOfSpellTrackerMinimapButton();
	
	SpellTrackerButton_UpdateTitle();
	
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame:SetWidth(SpellTrackerDB.Params.FrameWidth);
		SpellTrackerFrame:SetHeight(SpellTrackerDB.Params.FrameHeight);
		SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame:Hide();
	end
end
function hideSpellTrackerFrameButton_OnClick(self) -- Bouton pour fermer la mainFrame
	SpellTrackerMinimapButton_OnClick(self);
end
function resetSpellTrackerButton_OnClick(self) -- Bouton pour reset les sorts traqus
	SpellTrackerDB.SPELLS = {};
	SpellTrackerDB.currentSessionHealTotal = 0;
	SpellTrackerDB.currentSessionDamageTotal = 0;
	SpellTrackerMinimapButton_OnLoad();
	SpellTrackerMinimapButton_UpdateTitle();
	SpellTrackerButton_UpdateTitle();
	SpellTracker:UpdateFilteredSpellList();
	SpellTracker:UpdateFrame();
end
function FilterSpellTrackerButton_OnClick(self)
	if ( UnitAffectingCombat("player") == nil ) then -- hors combat
		SpellTracker.FilterBtnDown = not SpellTracker.FilterBtnDown;
		if ( SpellTracker.FilterBtnDown == true ) then
			SpellTrackerFrameMainMenuTitle:SetHeight(60);
			--SpellTrackerFrame:SetPoint(SpellTrackerFrame:GetPoint(), 0 , 30);
			--SpellTrackerFrame:SetHeight(SpellTrackerFrame:GetHeight() + 30 );
			SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame:Show();
			SpellTrackerFrameMainMenuTitleFilterBtn:LockHighlight();
			--SpellTrackerFrameMainMenuTitleFilterBtn:SetNormalTexture("Interface\\Buttons\\UI-DialogBox-Button-Down");
			SpellTracker:AutoRedimSpellTrackerFrame(SpellTracker.CountBarDisplayed);
		else
			SpellTrackerFrameMainMenuTitle:SetHeight(30);
			--SpellTrackerFrame:SetPoint(SpellTrackerFrame:GetPoint(), 0 , -30);
			--SpellTrackerFrame:SetHeight(SpellTrackerFrame:GetHeight() - 30 );
			SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame:Hide();
			SpellTrackerFrameMainMenuTitleFilterBtn:UnlockHighlight();
			--SpellTrackerFrameMainMenuTitleFilterBtn:SetNormalTexture("Interface\\Buttons\\UI-DialogBox-Button-Up");
			SpellTracker:AutoRedimSpellTrackerFrame(SpellTracker.CountBarDisplayed);
		end
	end
end
function SpellTrackerButtonTemplate_OnLoad(self)
	self.selected = false;
end
function SpellTrackerButtonTemplate_OnClick(self)
	SpellTracker:UpdateFilterButton(self);
	SpellTracker:UpdateDisplayedFiterFromButtons();
end
function SpellTrackerButton_UpdateTitle()
	local vers = SpellTracker.Version;
	local pName = SpellTrackerDB.CurrentPlayerTracked.Name;
	local srcORdst = "";
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		srcORdst = "SRC";
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then
		srcORdst = "DST";
	end
	if ( pName == nil ) then -- zone tracking
		SpellTrackerFrameMainMenuTitleTitleText:SetText("SpellTracker "..vers.." -- Zone Tracking Mode".." by "..srcORdst);
	else
		SpellTrackerFrameMainMenuTitleTitleText:SetText("SpellTracker "..vers.." -- Player Tracked : "..pName.." by "..srcORdst);
	end
end
function SpellTrackerButton_ShowTooltip(self, LMBtextToShow, LMDtextToShow)
	if ( LMBtextToShow and LMDtextToShow ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText("LMB :"..LMBtextToShow);
		GameTooltip:AddLine("LMD :"..LMDtextToShow);
		GameTooltip:Show();
	elseif ( LMBtextToShow and not LMDtextToShow ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(LMBtextToShow);
		GameTooltip:Show();
	elseif ( SpellTrackerDB.MsgToolTip ) then
		GameTooltip:SetOwner(self);
		GameTooltip:SetText(SpellTrackerDB.MsgToolTip);
		GameTooltip:Show();
	end
end
function SpellTrackerButton_HideTooltip(self)
	 GameTooltip:Hide();
end
function SpellTrackerBar_OnEnter(self) -- affiche des infos sup sur les sort traqus
	if ( self.VAR.Used ) then 
		SpellTracker:CalcEventsPerSec(true); -- on refesh ev/s
		GameTooltip:SetOwner(self);
		if ( self.VAR.SpellIndexer ) then
			local SpellStruct = SpellTrackerDB.FILTEREDSPELLS[self.VAR.SpellIndexer];
			if ( SpellStruct ) then
				local HitTypeColor = SpellTrackerDB.Params.HostileColor;
				if ( SpellStruct.HitType ) then
					if ( SpellStruct.HitType == "HEAL" ) then HitTypeColor = SpellTrackerDB.Params.FriendlyColor; end
				else
					HitTypeColor = SpellTrackerDB.Params.DefaultColor;
				end
				
				GameTooltip:SetText(HitTypeColor..SpellStruct.SpellName);
					
				local nBarRatio = tostring(self.VAR.SpellListToSort_Position).."/"..tostring(SpellTracker.CountBarToDisplay);
				GameTooltip:AddLine("Bar "..nBarRatio);
				
				-- colorise en vert ou en rouge selon que la source soie hostile ou friendly
				local SrcColor = SpellTrackerDB.Params.FriendlyColor;
				local DstColor = SpellTrackerDB.Params.FriendlyColor;
				if ( SpellStruct.SourceReaction == "REACTION_HOSTILE" ) then SrcColor = SpellTrackerDB.Params.HostileColor; end
				if ( SpellStruct.TargetReaction == "REACTION_HOSTILE" ) then DstColor = SpellTrackerDB.Params.HostileColor; end
					
				if ( SpellStruct.SourceType and SpellStruct.SourceName ) then
					GameTooltip:AddDoubleLine("Source Type/Name :",SrcColor..SpellStruct.SourceType.." / "..SpellStruct.SourceName);
				elseif ( SpellStruct.SourceType ) then
					GameTooltip:AddDoubleLine("Source Type :",SrcColor..SpellStruct.SourceType);
				elseif ( SpellStruct.SourceName ) then
					GameTooltip:AddDoubleLine("Source Name :",SrcColor..SpellStruct.SourceName);
				end
				
				if ( SpellStruct.TargetType and SpellStruct.TargetName ) then
					GameTooltip:AddDoubleLine("Source Type/Name :",SrcColor..SpellStruct.TargetType.." / "..SpellStruct.TargetName);
				elseif ( SpellStruct.TargetType ) then
					GameTooltip:AddDoubleLine("Source Type :",SrcColor..SpellStruct.TargetType);
				elseif ( SpellStruct.TargetName ) then
					GameTooltip:AddDoubleLine("Source Name :",SrcColor..SpellStruct.TargetName);
				end
				
				local StatBarColor = SpellTracker.StatusBarColors;
				
				-- Recup des donnes / 0.40
				local LocalStruct = {};
				if ( SpellStruct.AmountLine ) then
					LocalStruct.SpellHitAmount, LocalStruct.SpellHitAndCritAmount, 
						LocalStruct.SpellCritAmount, LocalStruct.SpellCritAndOverAmount, LocalStruct.SpellOverAmount, 
						LocalStruct.SpellOverAndAbsorbAmount, LocalStruct.SpellCritAndAbsorbAmount, LocalStruct.SpellAbsorbAmount
						= string.match(SpellStruct.AmountLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");

		
					-- self.HitType vaut "Heal" ou "Damage" / modif 0.40
					if ( SpellStruct.HitType ) then
						GameTooltip:AddLine("----- "..SpellStruct.HitType.." : -----");
						GameTooltip:AddDoubleLine("Total Produced :",SpellTrackerBar_FormatAmountValueToString(SpellStruct.SpellAmountTotal));
						GameTooltip:AddDoubleLine(StatBarColor.SpellHitAmount..SpellStruct.HitType.." Hit Amount :",StatBarColor.SpellHitAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellHitAmount).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.SpellHitAmount, 1, SpellStruct.SpellAmountTotal));
						GameTooltip:AddDoubleLine(StatBarColor.SpellCritAmount..SpellStruct.HitType.." Crit Amount :",StatBarColor.SpellCritAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAmount).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.SpellCritAmount, 1, SpellStruct.SpellAmountTotal));
						GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndOverAmount..SpellStruct.HitType.." Over & Crit Amount :",StatBarColor.SpellCritAndOverAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAndOverAmount).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.SpellCritAndOverAmount, 1, SpellStruct.SpellAmountTotal));
						GameTooltip:AddDoubleLine(StatBarColor.SpellOverAmount..SpellStruct.HitType.." Over Amount :",StatBarColor.SpellOverAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellOverAmount).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.SpellOverAmount, 1, SpellStruct.SpellAmountTotal));
						GameTooltip:AddDoubleLine(StatBarColor.SpellOverAndAbsorbAmount..SpellStruct.HitType.." Over & Absorb Amount :",StatBarColor.SpellOverAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellOverAndAbsorbAmount).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.SpellOverAndAbsorbAmount, 1, SpellStruct.SpellAmountTotal));
						GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndAbsorbAmount..SpellStruct.HitType.." Crit & Absorb Amount :",StatBarColor.SpellCritAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAndAbsorbAmount).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.SpellCritAndAbsorbAmount, 1, SpellStruct.SpellAmountTotal));
						GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount..SpellStruct.HitType.." Absorb Amount :",StatBarColor.SpellAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellAbsorbAmount).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.SpellAbsorbAmount, 1, SpellStruct.SpellAmountTotal));
					
					end
				end
				
				local NNumAfterComa = 1;
				local NNumAfterComaStr = "%."..tostring(NNumAfterComa).."f";
				-- nombre de chiffres apres la virgule -- string.format(NNumAfterComaStr, num);
				-- Recup des Ticks / 0.40
				if ( SpellStruct.TicksLine ) then
					LocalStruct.CountSpellHit, LocalStruct.CountSpellMissed, LocalStruct.CountSpellImmune, 
						LocalStruct.CountSpellAbsorb, LocalStruct.CountSpellOver, LocalStruct.CountSpellCrit, LocalStruct.CountSpellCritAndOver, 
						LocalStruct.CountSpellCritAndAbsorb, LocalStruct.CountSpellOverAndAbsorb
						= string.match(SpellStruct.TicksLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");
		
					if ( SpellStruct.HitType ) then
						GameTooltip:AddLine("----- "..SpellStruct.HitType.." Ticks : -----");
					end
					GameTooltip:AddDoubleLine("Count Ticks ", SpellStruct.CountTicks);
					GameTooltip:AddDoubleLine(StatBarColor.SpellHitAmount.." Count Hit ", StatBarColor.SpellHitAmount..(LocalStruct.CountSpellHit).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellHit, 1, SpellStruct.CountTicks));
					GameTooltip:AddDoubleLine(StatBarColor.SpellOverAmount.." Count Over ", StatBarColor.SpellOverAmount..(LocalStruct.CountSpellOver).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellOver, 1, SpellStruct.CountTicks));
					GameTooltip:AddDoubleLine(StatBarColor.SpellCritAmount.." Count Crits ", StatBarColor.SpellCritAmount..(LocalStruct.CountSpellCrit).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellCrit, 1, SpellStruct.CountTicks));
					GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndOverAmount.." Count Crit & Over ", StatBarColor.SpellCritAndOverAmount..(LocalStruct.CountSpellCritAndOver).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellCritAndOver, 1, SpellStruct.CountTicks));
					GameTooltip:AddDoubleLine(StatBarColor.SpellCritAndAbsorbAmount.." Count Crit & Absorb ", StatBarColor.SpellCritAndAbsorbAmount..(LocalStruct.CountSpellCritAndAbsorb).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellCritAndAbsorb, 1, SpellStruct.CountTicks));
					GameTooltip:AddDoubleLine(StatBarColor.SpellOverAndAbsorbAmount.." Count Over & Absorb ", StatBarColor.SpellOverAndAbsorbAmount..(LocalStruct.CountSpellOverAndAbsorb).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellOverAndAbsorb, 1, SpellStruct.CountTicks));
					GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Missed ", StatBarColor.SpellAbsorbAmount..(LocalStruct.CountSpellMissed).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellMissed, 1, SpellStruct.CountTicks));
					GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Immune ", StatBarColor.SpellAbsorbAmount..(LocalStruct.CountSpellImmune).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellImmune, 1, SpellStruct.CountTicks));
					GameTooltip:AddDoubleLine(StatBarColor.SpellAbsorbAmount.." Count Absorb ", StatBarColor.SpellAbsorbAmount..(LocalStruct.CountSpellAbsorb).." - "..SpellTrackerBar_FormatAmountToPercentValueToString(LocalStruct.CountSpellAbsorb, 1, SpellStruct.CountTicks));
				end
				
				GameTooltip:Show();
			end
		end
	end
end
function SpellTrackerBar_FormatAmountValueToString(val)
	if (string.len(tostring(val)) > 4 ) then
		return string.format("%.0f", val/1000).."K";
	elseif (string.len(tostring(val)) > 7 ) then
		return string.format("%.0f", val/1000000).."m";
	elseif (string.len(tostring(val)) > 10 ) then
		return string.format("%.0f", val/1000000).."M";
	else
		return string.format("%.0f", val);
	end
end
function SpellTrackerBar_FormatAmountToPercentValueToString(val, precision, total)
	local percentVal = (val*100)/total;
	return string.format("(%."..tostring(0).."f", percentVal).."%)";
end
function SpellTrackerBar_GetColorCodeFromStatusBarColor(StatusBar)
	local codeWow = nil;
	if ( StatusBar ) then
		local r,g,b,a = StatusBar:GetStatusBarColor();
		if ( r and g and b ) then
			codeWow = SpellTrackerBar_GetColorCodeFromRGB(r, g, b);
		end
	end
	return codeWow; 
end
function SpellTrackerBar_GetColorCodeFromRGB(red, green, blue) -- de 0  1 en float
	local codeWow = nil;
	if ( red and green and blue ) then
		local redColor = string.format("%0.2X", math.ceil(string.format("%.2f", red)*255));
		local greenColor = string.format("%0.2X", math.ceil(string.format("%.2f", green)*255));
		local blueColor = string.format("%0.2X", math.ceil(string.format("%.2f", blue)*255));
		codeWow = "|cFF"..tostring(redColor)..tostring(greenColor)..tostring(blueColor);
	end
	return codeWow; 
end
function SpellTrackerBar_GetColorCodeFromRGBStruct(rgbStruct) -- de 0  1 en float
	local codeWow = SpellTrackerBar_GetColorCodeFromRGB(rgbStruct.r, rgbStruct.g, rgbStruct.b);
	return codeWow; 
end
function SpellTrackerBar_OnLeave(self)
    GameTooltip:Hide();
end
function SpellTrackerMinimapButton_UpdateTitle(EventPerSec)
	if ( EventPerSec == nil or EventPerSec == 0 ) then
		SpellTrackerMinimapButton.label:SetText("SPT "..SpellTracker.Version);
	else
		SpellTrackerMinimapButton.label:SetText("SPT "..tostring(EventPerSec).."ev/s");
	end
end
function SpellTrackerMinimapButton_OnLoad(self)
	SpellTrackerMinimapButton_UpdateTitle();
end
function SpellTrackerMinimapButton_OnEnter(self)
	GameTooltip:SetOwner(self);
	GameTooltip:SetText("SpellTracker "..SpellTracker.Version);
	--GameTooltip:AddDoubleLine(SpellTrackerDB.Params.FriendlyColor.."Heal :",SpellTrackerDB.Params.FriendlyColor..tostring(SpellTrackerDB.currentSessionHealTotal));
	--GameTooltip:AddDoubleLine(SpellTrackerDB.Params.HostileColor.."Damage :",SpellTrackerDB.Params.HostileColor..tostring(SpellTrackerDB.currentSessionDamageTotal));
	GameTooltip:Show();
end
function SpellTrackerMinimapButton_OnLeave(self)
	GameTooltip:Hide();
end
function SpellTrackerMinimapButton_OnClick(self)
	if (SpellTrackerFrame) then
        if(SpellTrackerFrame:IsVisible() ) then
            SpellTracker.MinimapBtnDown = False;
			SpellTrackerMinimapButton:UnlockHighlight();
			SpellTrackerFrame:Hide();
		else
            SpellTrackerFrame:Show();
			SpellTracker.MinimapBtnDown = true;
			SpellTrackerMinimapButton:LockHighlight();
			SpellTracker:UpdateFilteredSpellList();
			SpellTracker:UpdateFrame();
		end
    end
end
function SpellTrackerResizeFrame_OnEnter(self) -- widget de redimentionnement -- survol IN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(false);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(1);
	end
end
function SpellTrackerResizeFrame_OnLeave(self) -- widget de redimentionnement -- survol OUT
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrameResizeFrameTexture:SetDesaturated(true);
		SpellTrackerFrameResizeFrameTexture:SetAlpha(0);
	end
end
function SpellTrackerResizeFrame_OnMouseDown(self) -- widget de redimentionnement -- CLICK DOWN
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTrackerFrame.isMovingOrSizing = false;
		local minHeight = SpellTrackerFrameMainMenuTitle:GetHeight() + SpellTrackerDB.Params.SpellBarHeight + 2;
		SpellTrackerFrame:SetMinResize(80, minHeight);
		SpellTrackerFrame:SetMaxResize(800, 0);
		SpellTrackerFrame:StartSizing();
	end
end
function SpellTrackerResizeFrame_OnMouseUp(self) -- widget de redimentionnement -- CLICK UP
	if ( UnitAffectingCombat("player") == nil ) then
		SpellTracker:AutoRedimSpellTrackerFrame();
		SpellTrackerFrame:StopMovingOrSizing();
		SpellTrackerFrame:ClearAllPoints();
		SpellTrackerFrame.isMovingOrSizing = nil;
		SpellTrackerDB.Params.FrameWidth = SpellTrackerFrame:GetWidth();
		
		SpellTracker:InitFrame(); -- on a redimentionn donc on reinit le layout	
		SpellTracker:UpdateFilteredSpellList(); -- on recalcule
		SpellTracker:UpdateFrame(); -- on update la frame
	end
end
function SpellTrackerFrameContainer_OnLoad(self) -- chargement du container du grid
	self:RegisterForDrag("LeftButton");
	--self:SetScrollChild(SpellTrackerFrameContainerContainer);
end
function SpellTrackerFrameContainerVirtualScrollBar_OnMouseWheel (self, delta, stepSize) -- se produit quand la molette de la sourie roule
	-- SpellTracker.ScrollValue => correspond au numro de la barre affich en haut
	-- SpellTracker.CountBarToDisplay => correspond au nombre de barres  afficher 
	-- SpellTracker.CountBarDisplayed => correspond au nombres de bars qui puevent etre affcihs en meme temps.
	if ( delta ) then
		local minVal, maxVal = 0, SpellTracker.CountBarToDisplay-SpellTracker.CountBarDisplayed;
		if ( maxVal < 0 ) then maxVal = 0; end
		--print("SpellTracker.CountBarDisplayed=",SpellTracker.CountBarDisplayed);
		if ( delta == 1 ) then
			SpellTracker.ScrollValue = max(minVal, SpellTracker.ScrollValue - SpellTrackerDB.Params.SrollStep);
		elseif ( delta == -1 ) then
			SpellTracker.ScrollValue = min(maxVal, SpellTracker.ScrollValue + SpellTrackerDB.Params.SrollStep);
		end
		
		SpellTracker:UpdateFrame();
	end
end	
function SpellTrackerFrame_OnLoad(self)
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_REGEN_DISABLED"); -- Get Aggro
    self:RegisterEvent("PLAYER_REGEN_ENABLED");	-- Leave Aggro
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED"); -- recuper les event de combat 
end
function SpellTrackerFrame_OnEvent(self, event, ...)
	if ( event == "VARIABLES_LOADED" ) then
		SpellTrackerFrame_Init(self);
		self:UnregisterEvent("VARIABLES_LOADED");
	elseif ( event == "PLAYER_ENTERING_WORLD" ) then
		if ( UnitAffectingCombat("player") == nil ) then
			SpellTracker:InitFrame();
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTracker.Version.." LOADED");
			SpellTracker:UpdateFrame();
			SpellTracker:CreateOrUpdateRaidMembersList(); -- on refresh la list des membre du raid
			SpellTracker:CreateOrUpdateGroupMembersList(); -- on refresh la lst des membres du groupe
			self:UnregisterEvent("PLAYER_ENTERING_WORLD");
		else
			DEFAULT_CHAT_FRAME:AddMessage("SpellTracker "..SpellTracker.Version.." NOT LOADED");
			DEFAULT_CHAT_FRAME:AddMessage("PLEASE RELOAD INTERFACE AFTER THE END OF YOUR FIGHT");
		end
	elseif ( event == "COMBAT_LOG_EVENT_UNFILTERED" ) then
		SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(self, ...);
	elseif ( event == "RAID_ROSTER_UPDATE" ) then
		SpellTracker:CreateOrUpdateRaidMembersList();
	elseif ( event == "PARTY_MEMBERS_CHANGED" ) then
		SpellTracker:CreateOrUpdateGroupMembersList();	
	end
	SpellTracker:CalcEventsPerSec(true); -- refresh ev/s
end
function SpellTracker_MyDropDownMenu_OnLoad()
    info = {};
    info.text = SpellTrackerDB.MenuDropDown_Target.It1.txt;
    info.value = "OptionVariable";
	info.checked = SpellTrackerDB.MenuDropDown_Target.It1.check;
    info.func = 
		function() 
			SpellTrackerDB.CurrentPlayerTracked.GUID = UnitGUID("player");
			SpellTrackerDB.CurrentPlayerTracked.Name = UnitName("player");
			SpellTrackerDB.CurrentPlayerTracked.lvl = UnitLevel("player");
			SpellTrackerDB.MenuDropDown_Target.It1.check = true;
			SpellTrackerDB.MenuDropDown_Target.It2.check = false;
			SpellTrackerDB.MenuDropDown_Target.It3.check = false;
			SpellTrackerDB.MenuDropDown_Target.It4.check = false;
			SpellTrackerDB.MenuDropDown_Target.It5.check = false;
			resetSpellTrackerButton_OnClick(self);
		end 
	UIDropDownMenu_AddButton(info);
	
	info = {};
    info.text = SpellTrackerDB.MenuDropDown_Target.It2.txt;
    info.value = "OptionVariable";
	info.checked = SpellTrackerDB.MenuDropDown_Target.It2.check;
    info.func = 
		function() 
			if ( UnitName("target") ~= nil ) then
				SpellTrackerDB.CurrentPlayerTracked.GUID = UnitGUID("target");
				SpellTrackerDB.CurrentPlayerTracked.Name = UnitName("target");
				SpellTrackerDB.CurrentPlayerTracked.lvl = UnitLevel("player");
				SpellTrackerDB.MenuDropDown_Target.It1.check = false;
				SpellTrackerDB.MenuDropDown_Target.It2.check = true;
				SpellTrackerDB.MenuDropDown_Target.It3.check = false;
				SpellTrackerDB.MenuDropDown_Target.It4.check = false;
				SpellTrackerDB.MenuDropDown_Target.It5.check = false;
				resetSpellTrackerButton_OnClick(self);
			end
		end 
	UIDropDownMenu_AddButton(info);
	
	info = {};
    info.text = SpellTrackerDB.MenuDropDown_Target.It3.txt;
    info.value = "OptionVariable";
	info.checked = SpellTrackerDB.MenuDropDown_Target.It3.check;
    info.func = 
		function() 
			SpellTrackerDB.CurrentPlayerTracked.GUID = nil;
			SpellTrackerDB.CurrentPlayerTracked.Name = nil;
			SpellTrackerDB.CurrentPlayerTracked.lvl = nil;
			SpellTrackerDB.MenuDropDown_Target.It1.check = false;
			SpellTrackerDB.MenuDropDown_Target.It2.check = false;
			SpellTrackerDB.MenuDropDown_Target.It3.check = true;
			SpellTrackerDB.MenuDropDown_Target.It4.check = false;
			SpellTrackerDB.MenuDropDown_Target.It5.check = false;
			resetSpellTrackerButton_OnClick(self);
		end 
	UIDropDownMenu_AddButton(info);
	
	info = {};
    info.text = SpellTrackerDB.MenuDropDown_Target.It4.txt;
    info.value = "OptionVariable";
	info.checked = SpellTrackerDB.MenuDropDown_Target.It4.check;
    info.func = 
		function() 
			if ( IsInRaid() ) then
				SpellTrackerDB.CurrentPlayerTracked.GUID = nil;
				SpellTrackerDB.CurrentPlayerTracked.Name = nil;
				SpellTrackerDB.CurrentPlayerTracked.lvl = nil;
				SpellTrackerDB.MenuDropDown_Target.It1.check = false;
				SpellTrackerDB.MenuDropDown_Target.It2.check = false;
				SpellTrackerDB.MenuDropDown_Target.It3.check = false;
				SpellTrackerDB.MenuDropDown_Target.It4.check = true;
				SpellTrackerDB.MenuDropDown_Target.It5.check = false;
				SpellTracker:CreateOrUpdateRaidMembersList();
				resetSpellTrackerButton_OnClick(self);
			end
		end 
	UIDropDownMenu_AddButton(info);
	
	info = {};
    info.text = SpellTrackerDB.MenuDropDown_Target.It5.txt;
    info.value = "OptionVariable";
	info.checked = SpellTrackerDB.MenuDropDown_Target.It5.check;
    info.func = 
		function() 
			if ( IsInGroup() ) then
				SpellTrackerDB.CurrentPlayerTracked.GUID = nil;
				SpellTrackerDB.CurrentPlayerTracked.Name = nil;
				SpellTrackerDB.CurrentPlayerTracked.lvl = nil;
				SpellTrackerDB.MenuDropDown_Target.It1.check = false;
				SpellTrackerDB.MenuDropDown_Target.It2.check = false;
				SpellTrackerDB.MenuDropDown_Target.It3.check = false;
				SpellTrackerDB.MenuDropDown_Target.It4.check = false;
				SpellTrackerDB.MenuDropDown_Target.It5.check = true;
				SpellTracker:CreateOrUpdateGroupMembersList();
				resetSpellTrackerButton_OnClick(self);
			end
		end 
	UIDropDownMenu_AddButton(info);
end
function SpellTracker_ShowTootlip_ForDropDownMenu(self)
	GameTooltip:SetOwner(self);
	local strToShow = "";
	if ( SpellTrackerDB.MenuDropDown_Target.It1.check == true ) then strToShow = SpellTrackerDB.MenuDropDown_Target.It1.txt;
	elseif ( SpellTrackerDB.MenuDropDown_Target.It2.check == true ) then strToShow = SpellTrackerDB.MenuDropDown_Target.It2.txt;
	elseif ( SpellTrackerDB.MenuDropDown_Target.It3.check == true ) then strToShow = SpellTrackerDB.MenuDropDown_Target.It3.txt;
	elseif ( SpellTrackerDB.MenuDropDown_Target.It4.check == true ) then strToShow = SpellTrackerDB.MenuDropDown_Target.It4.txt;
	elseif ( SpellTrackerDB.MenuDropDown_Target.It5.check == true ) then strToShow = SpellTrackerDB.MenuDropDown_Target.It5.txt;
	end
	GameTooltip:SetText(strToShow);
	GameTooltip:Show();
end
function SpellTracker_MyDropDownMenu2_OnLoad()
    info = {};
    info.text = SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.txt;
    info.value = "OptionVariable";
	info.checked = SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.check;
    info.func = 
		function() 
			SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = true;
			if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
				SpellTrackerDB.MsgToolTip = "Track Source";
			elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then -- peut valoir nil on sait jamais
				SpellTrackerDB.MsgToolTip = "Track Dest";
			end
			SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.check = true;
			SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.check = false;
			resetSpellTrackerButton_OnClick(self);
		end 
	UIDropDownMenu_AddButton(info);
	
	info = {};
    info.text = SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.txt;
    info.value = "OptionVariable";
	info.checked = SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.check;
    info.func = 
		function() 
			SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked = false;
			if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
				SpellTrackerDB.MsgToolTip = "Track Source";
			elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then -- peut valoir nil on sait jamais
				SpellTrackerDB.MsgToolTip = "Track Dest";
			end
			SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.check = false;
			SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.check = true;
			resetSpellTrackerButton_OnClick(self);
		end 
	UIDropDownMenu_AddButton(info);
end
function SpellTracker_ShowTootlip_ForDropDownMenu2(self)
	GameTooltip:SetOwner(self);
	local strToShow = "";
	if ( SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.check == true ) then strToShow = SpellTrackerDB.MenuDropDown_SRC_OR_DST.It1.txt;
	elseif ( SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.check == true ) then strToShow = SpellTrackerDB.MenuDropDown_SRC_OR_DST.It2.txt;
	end
	GameTooltip:SetText(strToShow);
	GameTooltip:Show();
end
-- kernel --
function SpellTracker:CreateOrUpdateRaidMembersList()
	local _guid;
	SpellTracker.RaidLst = {};
	tinsert(SpellTracker.RaidLst, UnitGUID("player")); -- je m'ajoute
	for idx=1,40 do
		_guid = UnitGUID("raid"..tostring(idx)); -- raid player member
		if ( _guid ) then tinsert(SpellTracker.RaidLst, _guid); end
		_guid = UnitGUID("raidpet"..tostring(idx)); -- raid pet member
		if ( _guid ) then tinsert(SpellTracker.RaidLst, _guid); end
	end
end
function SpellTracker:CreateOrUpdateGroupMembersList()
	local _guid;
	SpellTracker.PartyLst = {};
	tinsert(SpellTracker.PartyLst, UnitGUID("palyer")); -- je m'ajoute
	for idx=1,5 do
		_guid = UnitGUID("party"..tostring(idx)); -- party player member
		if ( _guid ) then tinsert(SpellTracker.PartyLst, _guid); end
		_guid = UnitGUID("partypet"..tostring(idx)); -- party pet member
		if ( _guid ) then tinsert(SpellTracker.PartyLst, _guid); end
	end
end
function SpellTracker:InitDataStruct(dataStruct) -- 0.43 OK
	if ( dataStruct ) then
		if ( type(dataStruct ) == "string" ) then
			SpellTrackerDB.Params.DataStruct = SpellTrackerDB.Params.DataStruct or dataStruct;
			-- 0.41 / on extrait la structure de donne et les filtres d'affichage
			SpellTrackerDB.DataStruct = SpellTracker:StringFiltering(SpellTrackerDB.Params.DataStruct, "(%S+)>(%S+)");
			SpellTrackerDB.DataStructInv = SpellTracker:StringFilteringInv(SpellTrackerDB.Params.DataStruct, "(%S+)>(%S+)");
			return true;
		end
		return false;
	end
	return false;
end
function SpellTracker:InitDisplayedFilter(dispFilter) -- 0.43 OK
	if ( dispFilter ) then
		if ( type(dispFilter ) == "string" ) then
			SpellTrackerDB.Params.DisplayedFilters = SpellTrackerDB.Params.DisplayedFilters or dispFilter;
			-- 0.41 / on extrait la structure de donne et les filtres d'affichage
			SpellTrackerDB.DisplayedFilters = SpellTracker:StringFiltering(SpellTrackerDB.Params.DisplayedFilters, "(%S+)+(%S+)");
			SpellTrackerDB.DisplayedFiltersInv = SpellTracker:StringFilteringInv(SpellTrackerDB.Params.DisplayedFilters, "(%S+)+(%S+)");
			return true;
		end
		return false;
	end
	return false;
end
function SpellTracker:InitFilterFrame() -- 0.43 OK
	if ( SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame ) then
		if ( not SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons ) then
			local BtnName = "SpellTrackerFilterBtn";
			local lastBtn = nil;
			for k=0, #SpellTrackerDB.DataStruct do
				local btnName = BtnName..tostring(k);
				local btn = CreateFrame("Button", btnName, SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame, "SpellTrackerButtonTemplate");
				if ( btn ) then
					SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons = SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons or {};
					SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons[k] = btn;
					btn.idx = k;
					btn.selected = false;
					local btnName = SpellTrackerDB.DataStruct[k];
					if ( btnName ) then
						btn.label.nameStr = SpellTrackerDB.DataStruct[k];
						btn.label:SetText(btn.label.nameStr);
					end
					if ( k == 0 ) then
						btn:SetPoint("TOPLEFT", SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame, "TOPLEFT", 5, -2);
					else
						btn:SetPoint("TOPLEFT", lastBtn, "TOPRIGHT", -1, 0);
					end
					btn:Show();
					lastBtn = btn;
				end
			end
		end
	end
end
function SpellTracker:AutoResizeFilterFrame() -- 0.43 OK
	if ( SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame ) then
		local FrameWidth = SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame:GetWidth();
		if ( SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons ) then
			local CountBtn = #SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons+1; -- +1 a cause du 0
			local NewWidth = math.floor(FrameWidth/CountBtn);
			for index, btn in pairs(SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons) do
				if ( btn ) then
					btn:SetWidth(NewWidth);
					if ( btn.label ) then
						SpellTracker:ModifyBtnLabelAccordingToFinalWiudth(btn.label, NewWidth);
					end
				end
			end
		end
	end
end
function SpellTracker:ModifyBtnLabelAccordingToFinalWiudth(btnLabel, finalWidth) -- 0.43 OK
	local name = btnLabel.nameStr;
	local substring;
	for length=#name, 1, -1 do
		substring = SpellTracker:utf8sub(name, 1, length);
		btnLabel:SetText(substring);
		if ( btnLabel:GetStringWidth() <= finalWidth ) then
			return
		end
	end
end
function SpellTracker:utf8sub(str, start, numChars) -- 0.43 OK
	-- This function can return a substring of a UTF-8 string, properly
	-- handling UTF-8 codepoints. Rather than taking a start index and
	-- optionally an end index, it takes the string, the start index, and
	-- the number of characters to select from the string.
	--
	-- UTF-8 Reference:
	-- 0xxxxxx - ASCII character
	-- 110yyyxx - 2 byte UTF codepoint
	-- 1110yyyy - 3 byte UTF codepoint
	-- 11110zzz - 4 byte UTF codepoint
	local currentIndex = start
	while numChars > 0 and currentIndex <= #str do
		local char = string.byte(str, currentIndex)
		if char >= 240 then
			currentIndex = currentIndex + 4
		elseif char >= 225 then
			currentIndex = currentIndex + 3
		elseif char >= 192 then
			currentIndex = currentIndex + 2
		else
			currentIndex = currentIndex + 1
		end
		numChars = numChars - 1
	end
	return str:sub(start, currentIndex - 1)
end
function SpellTracker:UpdateDisplayedFiterFromButtons() -- 0.43 simplification OK -- 0.42 -- met  jour SpellTrackerDB.Params.DisplayedFilters en fonction de l'tat de selction des filtres
	local filterString = "";
	local btns = SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons;
	for i=0, #btns do
		local cBtn = btns[i];
		if ( cBtn ) then
			if ( cBtn.selected ) then
				if ( i == 0 ) then
					filterString = filterString..cBtn.label.nameStr;
				else
					filterString = filterString.."+"..cBtn.label.nameStr;
				end
			end
		end
	end		
	SpellTrackerDB.Params.DisplayedFilters = filterString;
	SpellTrackerDB.DisplayedFilters = SpellTracker:StringFiltering(SpellTrackerDB.Params.DisplayedFilters, "(%S+)+(%S+)");
	SpellTrackerDB.DisplayedFiltersInv = SpellTracker:StringFilteringInv(SpellTrackerDB.Params.DisplayedFilters, "(%S+)+(%S+)");
	SpellTracker:UpdateFilteredSpellList();
	SpellTracker:UpdateFrame();							
end
function SpellTracker:UpdateButtonsFromDisplayedFiter() -- 0.43 simplfication OK -- 0.42 -- met a jour l'tat des boutons de slection des filtres en focntion de SpellTrackerDB.Params.DisplayedFilters
	local count = #SpellTrackerDB.DisplayedFilters;
	local btns = SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons;
	SpellTracker:UpdateFilterButton(btns[count]);			
end
function SpellTracker:UpdateFilterButton(btn) -- 0.43 OK
	if ( btn ) then
		if ( btn.selected == false ) then -- alors on selction tout les boutons qui sont avant et on deseltionne ceux qui sont apres
			self.selected = true;
			btn:LockHighlight();
			local btnPos = btn.idx;
			local btns = SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons;
			for i=0, #btns do
				local cBtn = btns[i];
				if ( cBtn ) then
					if ( i <= btnPos ) then
						cBtn.selected = true;
						cBtn:LockHighlight();
					else
						cBtn.selected = false;
						cBtn:UnlockHighlight();
					end
				end
			end
		else -- alors on deselectionne tout les boutons qui sont apres
			local btnPos = btn.idx+1; -- on prends le bouton d'apres
			local btns = SpellTrackerFrameMainMenuTitleDisplayFilterSelectFrame.Buttons;
			for i=btnPos, #btns do
				local cBtn = btns[i];
				if ( cBtn ) then
					cBtn.selected = false;
					cBtn:UnlockHighlight();
				end
			end
		end
	end
end
function SpellTracker:CalcEventsPerSec(refresh) -- calcul le nombre de tick de spell track log par second
	if ( refresh == nil or refresh == false ) then
		local tickTime = math.floor(GetTime());
		if ( tickTime == SpellTracker.EventPerSec_LastTickTime ) then -- tick ++
			SpellTracker.EventPerSec_Ticks = SpellTracker.EventPerSec_Ticks + 1;
		else -- new seconde
			--local newWidth = 70 + string.len(tostring(EventPerSec_Ticks))*5;
			if ( SpellTracker.EventPerSec_Ticks > SpellTrackerDB.Record.MaxEventPerSecValue ) then -- on enregistre le record de Event/s
				SpellTrackerDB.Record.MaxEventPerSecValue = SpellTracker.EventPerSec_Ticks;
			end
			SpellTracker:AdjustColorOfSpellTrackerMinimapButton();
			SpellTrackerMinimapButton_UpdateTitle(SpellTracker.EventPerSec_Ticks);
			SpellTracker.EventPerSec_Ticks = 0;
		end
		SpellTracker.EventPerSec_LastTickTime = tickTime;
	else -- on rafraichit juste
		if ( SpellTracker.EventPerSec_Ticks > 0 ) then
			local tickTime = math.floor(GetTime());
			if ( tickTime - SpellTracker.EventPerSec_LastTickTime > SpellTrackerDB.Params.EventPerSec_SeuilInSecBeforeReset ) then 
				SpellTracker.EventPerSec_Ticks = 0;
				SpellTrackerMinimapButton_UpdateTitle(SpellTracker.EventPerSec_Ticks);
				SpellTracker:AdjustColorOfSpellTrackerMinimapButton();
			end
		end
	end
end
function SpellTracker:AdjustColorOfSpellTrackerMinimapButton()
	if ( SpellTracker.EventPerSec_Ticks > 10 ) then -- Orange
		SpellTrackerMinimapButton.background:SetVertexColor(0.5,0.5,0,1);
		SpellTrackerMinimapButton.highlight:SetVertexColor(0.5,0.5,0,1);
	elseif ( SpellTracker.EventPerSec_Ticks > 100 ) then -- Rouge
		SpellTrackerMinimapButton.background:SetVertexColor(1,0,0,1);
		SpellTrackerMinimapButton.highlight:SetVertexColor(1,0,0,1);
	else -- rien
		SpellTrackerMinimapButton.background:SetVertexColor(0,1,0,1);
		SpellTrackerMinimapButton.highlight:SetVertexColor(0,1,0,1);
	end
end
function SpellTracker:AutoRedimSpellTrackerFrame(CountDisplayedBar)
	SpellTrackerFrame.isMovingOrSizing = false;
	SpellTrackerFrame:StartSizing();
	-- on reajuste la valuer y a un mulitple de Hbarre + offsety
	local barHeight = SpellTrackerDB.Params.SpellBarHeight + 2; -- 2 == offset
	local minHeight = SpellTrackerFrameMainMenuTitle:GetHeight() + barHeight;
	if ( CountDisplayedBar == nil ) then 
		CountDisplayedBar = math.floor(SpellTrackerFrameContainer:GetHeight() / barHeight); 
		SpellTracker.CountBarDisplayed = CountDisplayedBar;
	end
	local newSpellTrackerFrameContainerHeight = CountDisplayedBar*barHeight;
	local newSpellTrackerFrameHeight = (SpellTrackerFrame:GetHeight() - SpellTrackerFrameContainer:GetHeight()) + newSpellTrackerFrameContainerHeight;
	if ( newSpellTrackerFrameHeight < minHeight ) then newSpellTrackerFrameHeight = minHeight; end
	SpellTrackerFrame:SetHeight(newSpellTrackerFrameHeight);
	SpellTrackerDB.Params.FrameHeight = newSpellTrackerFrameHeight;
	SpellTrackerFrame:StopMovingOrSizing();
	SpellTrackerFrame.isMovingOrSizing = nil;
	
	-- redim buttons on FilterFrame
	SpellTracker:AutoResizeFilterFrame();
end
function SpellTracker:CreateBar(frmName)
    local GuiBar = CreateFrame("Button", frmName, SpellTrackerFrame, "SpellTrackerBarTemplate");
        
	GuiBar:RegisterForClicks("AnyUp");
	
	GuiBar.GUI = {};
	GuiBar.GUI.SpellIcon = _G[frmName.."StatusBarSpellHitSpellIcon"];
	GuiBar.GUI.SpellNameLabel = _G[frmName.."StatusBarSpellHitSpellNameLabel"];
	GuiBar.GUI.SpellSpellAmountLabel = _G[frmName.."StatusBarSpellHitSpellAmountLabel"];
	--GuiBar.GUI.SpellOverHitLabel = _G[frmName.."StatusBarSpellHitSpellOverHitLabel"];
	--GuiBar.GUI.SpellCritAmountLabel = _G[frmName.."StatusBarSpellHitSpellCritAmountLabel"];
	--GuiBar.GUI.SpellAbsorbAmountLabel = _G[frmName.."StatusBarSpellHitSpellAbsorbAmountLabel"];
	--GuiBar.GUI.SpellOverHitAndAbsorbAmount = _G[frmName.."StatusBarSpellHitSpellOverHitAndAbsorbAmountLabel"];
	--GuiBar.GUI.SpellCritAndAbsorbAmount = _G[frmName.."StatusBarSpellHitSpellCritAndAbsorbAmountLabel"];
	
	GuiBar.GUI.StatusBarSpellHit = _G[frmName.."StatusBarSpellHit"];
	GuiBar.GUI.StatusBarSpellHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAmountAndHit = _G[frmName.."StatusBarSpellCritAmountAndHit"];
	GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAmount = _G[frmName.."StatusBarSpellCritAmount"];
	GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAmount:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHitAndCrit = _G[frmName.."StatusBarSpellOverHitAndCrit"];
	GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHit = _G[frmName.."StatusBarSpellOverHit"];
	GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHit:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb = _G[frmName.."StatusBarSpellOverHitAndAbsorb"];
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(0);
	GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellCritAndAbsorb = _G[frmName.."StatusBarSpellCritAndAbsorb"];
	GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(0);
	GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetMinMaxValues(0, 100);
	
	GuiBar.GUI.StatusBarSpellAbsorbAmount = _G[frmName.."StatusBarSpellAbsorbAmount"];
	GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(0);
	GuiBar.GUI.StatusBarSpellAbsorbAmount:SetMinMaxValues(0, 100);
	
	if ( SpellTracker.StatusBarColors == nil ) then -- pour le tooltip de la barre
		SpellTracker.StatusBarColors = {};
		SpellTracker.StatusBarColors.SpellHitAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellHit)
		SpellTracker.StatusBarColors.SpellCritAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellCritAmount)
		SpellTracker.StatusBarColors.SpellCritAndOverAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHitAndCrit)
		SpellTracker.StatusBarColors.SpellOverAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHit)
		SpellTracker.StatusBarColors.SpellOverAndAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellOverHitAndAbsorb)
		SpellTracker.StatusBarColors.SpellCritAndAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellCritAndAbsorb)
		SpellTracker.StatusBarColors.SpellAbsorbAmount = SpellTrackerBar_GetColorCodeFromStatusBarColor(GuiBar.GUI.StatusBarSpellAbsorbAmount)
	end
    GuiBar.VAR = {};
	GuiBar.VAR.SpellIndexer = nil;
	GuiBar.VAR.SpellTracked = false; -- si le spell est demand a traquer
	GuiBar.VAR.Used = false; -- indique si la barre affiche des donnes actuellment ( remeit  false pendant le reset de la barre )
	
	GuiBar:SetBackdropColor(0.1, 0.1, 0.1, 0.9);
    GuiBar:SetBackdropBorderColor(0, 0, 0, 0);
	
	return GuiBar;
end
function SpellTracker:ResetBar(GuiBar)
	if ( GuiBar ) then
		GuiBar.GUI.SpellIcon:SetTexture(1,1,1,0); -- on la rend transparante => texture:SetTexture(r, g, b[, a]) avec a = 0
		GuiBar.GUI.SpellNameLabel:SetText("");
		GuiBar.GUI.SpellSpellAmountLabel:SetText("");
		
		GuiBar.GUI.StatusBarSpellHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAmount:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHit:SetValue(0);
		GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(0);
		GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(0);
		GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(0);
		
		GuiBar.VAR.Used = false;
	end
end
function SpellTracker:InitFrame()
	local mFrameContainer = SpellTrackerFrameContainer;
	SpellTracker.CountBarDisplayed = math.floor(mFrameContainer:GetHeight() / (SpellTrackerDB.Params.SpellBarHeight + 2));
	SpellTracker:AutoRedimSpellTrackerFrame(SpellTracker.CountBarDisplayed);
	--print("SpellTracker.CountBarDisplayed=",SpellTracker.CountBarDisplayed);
	--SpellTrackerDB.Params.SrollStep = math.floor(SpellTracker.CountBarDisplayed/3); -- le nombre de barres qu'on peut afficher sur 3 est un bon ration mais que ce apsste
	
	local idx = 1;
	if ( #SpellTracker.BARS < SpellTracker.CountBarDisplayed ) then
		local countBarToCreate = SpellTracker.CountBarDisplayed; --SpellTrackerDB.Params.DefaultCountSpellsToTrack; tait dfini par parametrage avant et coutait pas mal de mmoire du coup
		for k=0,countBarToCreate do 
			local frmName = "SpellTrackerBar"..tostring(idx);
			if ( _G[frmName] == nil ) then -- si la barre a pas encore t cr on la cr / permet de s'assurer qu'on aura tujours un nombre de barres suffisant et en corlation avec la fenetre
				local Bar = SpellTracker:CreateBar(frmName);
				--Bar:Hide();
				SpellTracker.BARS[idx] = Bar;
			end
			idx = idx + 1;
		end
	else
		-- on montre celles qui doivent etre utilise et on cache les autres
		for i=0, #SpellTracker.BARS do
			local frmName = "SpellTrackerBar"..tostring(i);
			if ( _G[frmName] ) then
				if ( i <= SpellTracker.CountBarDisplayed ) then
					_G[frmName]:Show(); 
				else
					_G[frmName]:Hide(); 
				end
			end
		end
	end
	
	local offsetY = -2;
    
	local ncolMax, nrowMax, itW, itH = 0, 0, 0, 0;
	local nrowMax = math.ceil(#SpellTracker.BARS);
	
	mFrameContainer:SetWidth(SpellTrackerFrame:GetWidth());
	
	local itW = mFrameContainer:GetWidth();
    local itH = SpellTrackerDB.Params.SpellBarHeight;
	
	local heightMax = nrowMax * itH + offsetY * nrowMax * -1;
	
	mFrameContainer:SetHeight(heightMax);
	
    local lastGuiBar = nil;
	for idx, guiBar in pairs(SpellTracker.BARS) do
		if ( guiBar ) then
			guiBar:SetParent(mFrameContainer);
			if ( lastGuiBar == nil ) then
				guiBar:SetPoint("TOPLEFT", mFrameContainer, "TOPLEFT", 0, 0);
			else
				guiBar:SetPoint("TOPLEFT", lastGuiBar, "BOTTOMLEFT", 0, offsetY);
			end
			guiBar:SetWidth(itW);
			guiBar:SetHeight(itH);
			lastGuiBar = guiBar;
		end
    end
	-- FilterFrame
	SpellTracker:InitFilterFrame();
	SpellTracker:AutoResizeFilterFrame();
	SpellTracker:UpdateButtonsFromDisplayedFiter();
end
function SpellTracker:CopyVar(varToCopy) -- quand je fait var2 = var1 les adresse des sous-object restent identique donc var1.toto = var2.toto
    local copiedVar = {};
    for k,v in pairs(varToCopy) do
        copiedVar[k] = v;
    end
    return copiedVar
end
function SpellTracker:RecursExploringOfStructureAccordingToFilters(key, tbl, saveStruct) -- 0.42 debug -- 0.41 recurs          
	if ( tbl.help == "SpellName" ) then
		saveStruct.SpellName = key;
		saveStruct.SpellIconTex = tbl.SpellIconTex;
		saveStruct.SpellId = tbl.SpellId;
	end
	saveStruct[tbl.help] = key;
	saveStruct.Indexer = saveStruct.Indexer or "";
	saveStruct.Indexer = saveStruct.Indexer.."_"..key;
	-- ca merde parce que je fait un copie du conetneur mais les adresse des objet du conatiner pointent toujours au meme endroit.
	for k,v in pairs(tbl) do
		if ( v ) then
            if ( type(v) == "table" ) then
				if ( v.help ) then
					if ( string.match(SpellTrackerDB.Params.DisplayedFilters, v.help) ) then -- si la key est voule ou contineu plus loins
                        local localStruct = SpellTracker:CopyVar(saveStruct);
						SpellTracker:RecursExploringOfStructureAccordingToFilters(k, v, localStruct);
					else
						--print("DisplayedFilters ne contient pas ", v.help);
					end
				end
			else
				if ( k == "SpellAmountTotal") then
					saveStruct.SpellAmountTotal = v;
				elseif ( k == "CountTicks" ) then
					saveStruct.CountTicks = v;
				elseif ( k == "TicksLine" ) then
					saveStruct.TicksLine = v;
				elseif ( k == "AmountLine" ) then
					saveStruct.AmountLine = v;
				end
			end
		end
	end
    -- si on est au dernier noeud on sauve
    if ( SpellTrackerDB.DisplayedFiltersInv[tbl.help] == SpellTrackerDB.DisplayedFiltersInv.count ) then
		SpellTrackerDB.FILTEREDSPELLS[saveStruct.Indexer] = saveStruct;
        SpellTrackerDB.FILTEREDSPELLS.count = SpellTrackerDB.FILTEREDSPELLS.count + 1; -- nombre
    end
	
end
function SpellTracker:UpdateBarStructureAccordingToFilters() -- 0.41 / rempli ou met  jour SpellTrackerDB.FILTEREDSPELLS en fonction des filtres d'affichage et de la strucutre de donnee
	-- le but du jeu c'est de parcourir la bd et et des qu'on rentre dans une structure qui est visiable dans la liste des filtre  afficher on 
	local SpellStruct = SpellTrackerDB.SPELLS;
	SpellTrackerDB.FILTEREDSPELLS = {};
	SpellTrackerDB.FILTEREDSPELLS.count = 0;
	local saveStruct = nil;
    for k,v in pairs(SpellStruct) do
		if ( type(v) == "table" ) then
            if ( v.help ) then
				 if ( string.match(SpellTrackerDB.Params.DisplayedFilters, v.help) ) then -- si la key est voule ou contineu plus loins
                    SpellTracker:RecursExploringOfStructureAccordingToFilters(k, v, {});
                end
            end
		end
	end
end
function SpellTracker:UpdateFilteredSpellList() -- recree la liste a afficher en fonction des filtre
	SpellTracker:UpdateBarStructureAccordingToFilters(); -- rempli SpellTrackerDB.FILTEREDSPELLS
	SpellTracker.SpellListToSort = {};
	for spellIndexer, spellStruct in pairs(SpellTrackerDB.FILTEREDSPELLS) do
        if ( spellIndexer and spellStruct ) then 
			if ( type(spellStruct) == "table" ) then
				tinsert(SpellTracker.SpellListToSort, spellStruct);
			end
        end
    end
	--print(#SpellTracker.SpellListToSort);
	sort(SpellTracker.SpellListToSort, 
		function(x,y)
			if ( x and y ) then
				if  ( x.SpellAmountTotal and y.SpellAmountTotal ) then
					return ( x.SpellAmountTotal > y.SpellAmountTotal ) ;
				elseif ( x.SpellAmountTotal ) then 
					return true; 
				elseif ( y.SpellAmountTotal ) then 
					return false;
				else -- not ( x.SpellTracked and y.SpellTracked ) 
					return ( x.SpellName < y.SpellName ) ;
				end	
			end
		end);
end
function SpellTracker:UpdateFrame() -- 0.41 / affiche simplement mais ne recalcule aucune liste
	for i, bar in pairs(SpellTracker.BARS) do
		if ( bar ) then
			if ( bar.VAR.Used ) then -- la barre est utlise;
				SpellTracker:ResetBar(bar); -- on la reset, car la cahcher va porvoquer une erreur en combat
			end
		end
	end
	
	local StatBarColor = SpellTracker.StatusBarColors;
				
	local SpellListToSort_Position = 1;
	local idx = 1; 
	
	for spellIndexer, spellStruct in pairs(SpellTracker.SpellListToSort) do
		if ( spellIndexer and spellStruct ) then
			if ( SpellListToSort_Position > SpellTracker.ScrollValue and SpellListToSort_Position <= (SpellTracker.ScrollValue + SpellTracker.CountBarDisplayed) ) then -- correspond a la position de la barre dsire comme cela on n'naffiche que les barres qui sont affichable -- gain mmoire donc
				local GuiBar = SpellTracker.BARS[idx];
				if ( GuiBar ) then
					GuiBar.GUI.SpellIcon:SetTexture(spellStruct.SpellIconTex); -- Spell Icon
					GuiBar.VAR.SpellIndexer = spellStruct.Indexer;
					
					GuiBar.VAR.SpellListToSort_Position = SpellListToSort_Position;
					
					-- plus besoin d'afficher un D ou un H => a la palce j'utilise la couleur rouge pour d et vert pour h
					local HitTypeColor  = "";
					if ( spellStruct.HitType ) then
						if ( spellStruct.HitType == "HEAL" ) then HitTypeColor = SpellTrackerDB.Params.FriendlyColor; -- heal en vert
						else HitTypeColor = SpellTrackerDB.Params.HostileColor; end -- degat en rouge
					end
					
					local TargetType  = "";
					if ( spellStruct.TargetType ) then
						if ( spellStruct.TargetType == "player" ) then TargetType = "P";
						elseif ( spellStruct.TargetType == "mob" ) then TargetType = "M";
						elseif ( spellStruct.TargetType == "vehicle" ) then TargetType = "V";
						elseif ( spellStruct.TargetType == "pet" ) then TargetType = "p";
						end
					end
					
					local SourceType  = "";
					if ( spellStruct.SourceType ) then
						if ( spellStruct.SourceType == "player" ) then SourceType = "P";
						elseif ( spellStruct.SourceType == "mob" ) then SourceType = "M";
						elseif ( spellStruct.SourceType == "vehicle" ) then SourceType = "V";
						elseif ( spellStruct.SourceType == "pet" ) then SourceType = "p";
						end
					end
					
					local SpellDirection = "";
					if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then SpellDirection = " => ";
					else SpellDirection = " <= ";
					end
					
					-- colorise en vert ou en rouge selon que la source soie hostile ou friendly
					local SourceName = "";
					if ( spellStruct.SourceReaction ) then
						if ( spellStruct.SourceReaction == "REACTION_HOSTILE" ) then -- Hostile
							if ( spellStruct.SourceName ) then
								SourceName = SpellTrackerDB.Params.HostileColor..spellStruct.SourceName;
							end
							if ( spellStruct.SourceType ) then
								SourceType = SpellTrackerDB.Params.HostileColor..SourceType;
							end
						else -- Friendly
							if ( spellStruct.SourceName ) then
								SourceName = SpellTrackerDB.Params.FriendlyColor..spellStruct.SourceName;
							end
							if ( spellStruct.SourceType ) then
								SourceType = SpellTrackerDB.Params.FriendlyColor..SourceType;
							end
						end
					else
						if ( spellStruct.SourceName ) then
							SourceName = SpellTrackerDB.Params.DefaultColor..spellStruct.SourceName;
						end
						if ( spellStruct.SourceType ) then
							SourceType = SpellTrackerDB.Params.DefaultColor..SourceType;
						end
					end
					
					-- colorise en vert ou en rouge selon que la cible soie hostile ou friendly
					local TargetName = "";
					if ( spellStruct.TargetReaction ) then
						if ( spellStruct.TargetReaction == "REACTION_HOSTILE" ) then -- Hostile
							if ( spellStruct.TargetName ) then
								TargetName = SpellTrackerDB.Params.HostileColor..spellStruct.TargetName;
							end
							if ( spellStruct.TargetType ) then
								TargetType = SpellTrackerDB.Params.HostileColor..TargetType;
							end
						else -- Friendly
							if ( spellStruct.TargetName ) then
								TargetName = SpellTrackerDB.Params.FriendlyColor..spellStruct.TargetName;
							end
							if ( spellStruct.TargetType ) then
								TargetType = SpellTrackerDB.Params.FriendlyColor..TargetType;
							end
						end
					else
						if ( spellStruct.TargetName ) then
							TargetName = SpellTrackerDB.Params.DefaultColor..spellStruct.TargetName;
						end
						if ( spellStruct.TargetType ) then
							TargetType = SpellTrackerDB.Params.DefaultColor..TargetType;
						end
					end
					
					-- on cree le titre en fonction de la strucutre de donn et des filtre d'affichage
					-- DataStruct => lui donne l'ordre d'affichage des item
					-- DisplayedFilters => lui donne les item a prendre en compte pour l'affichage
					--[[
						[0]="SpellName", -- permet de pas tre embt avec un sort en 8... et son tick en 10... ( ce serait bien de faire le distinguo..; => a voir )
						[1]="HitType", -- le meme sort peux faire du heal et du dgat
						[2]="SourceType", -- Mob / Player / Pet / Vehicle
						[3]="SourceReaction", -- raction de la source par rapport a mon perso
						[4]="SourceName", -- Name
						[5]="TargetType", -- Mob / Player / Pet / Vehicle
						[6]="TargetReaction", -- raction de la cible par rapport a mon perso
						[7]="TargetName" -- Name
					]]--
					local SpellNameLabel = tostring(SpellListToSort_Position); -- numro de la barre
					for i=0,#SpellTrackerDB.DataStruct do
						--print(SpellNameLabel);
						local item = SpellTrackerDB.DataStruct[i];
						if ( item ) then
							if ( string.match(SpellTrackerDB.Params.DisplayedFilters, item) ) then
								if ( item == "SpellName" ) then
									local spellName = "";
									if ( string.match(SpellTrackerDB.Params.DisplayedFilters, "HitType") ) then
										spellName = tostring(HitTypeColor);
									end
									SpellNameLabel = SpellNameLabel..spellName.." "..tostring(spellStruct.SpellName);
									if ( spellStruct.CountTicks ) then
										SpellNameLabel = SpellNameLabel..SpellTrackerDB.Params.DefaultColor.." x"..tostring(spellStruct.CountTicks).." "; -- default color pour les ticks
									end
								elseif ( item=="SourceType" ) then -- Mob / Player / Pet / Vehicle*
									SpellNameLabel = SpellNameLabel..tostring(SourceType).." ";
								--elseif ( item=="SourceReaction" ) then -- raction de la source par rapport a mon perso
									--SpellNameLabel = SpellNameLabel..tostring(spellStruct.SourceReaction).." ";
								elseif ( item=="SourceName" ) then -- Name
									SpellNameLabel = SpellNameLabel..tostring(SourceName).." ";
								elseif ( item=="TargetType" ) then -- Mob / Player / Pet / Vehicle
									SpellNameLabel = SpellNameLabel..SpellTrackerDB.Params.DefaultColor..SpellDirection.." "..tostring(TargetType).." ";
								--elseif ( item=="TargetReaction" ) then -- raction de la cible par rapport a mon perso
									--SpellNameLabel = SpellNameLabel..tostring(spellStruct.TargetReaction).." ";
								elseif ( item=="TargetName" ) then -- Name
									SpellNameLabel = SpellNameLabel..tostring(TargetName).." ";
								end
							end
						end
					end
					GuiBar.GUI.SpellNameLabel:SetText(	SpellNameLabel );
			
					-- On recupe les donnes Amount / 0.40
					local LocalStruct = {};
					if ( spellStruct.AmountLine ) then
						LocalStruct.SpellHitAmount, LocalStruct.SpellHitAndCritAmount, 
							LocalStruct.SpellCritAmount, LocalStruct.SpellCritAndOverAmount, LocalStruct.SpellOverAmount, 
							LocalStruct.SpellOverAndAbsorbAmount, LocalStruct.SpellCritAndAbsorbAmount, LocalStruct.SpellAbsorbAmount
							= string.match(spellStruct.AmountLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");
						LocalStruct.SpellHitAmount = tonumber(LocalStruct.SpellHitAmount);
						LocalStruct.SpellHitAndCritAmoun4t = tonumber(LocalStruct.SpellHitAndCritAmount);
						LocalStruct.SpellCritAmount = tonumber(LocalStruct.SpellCritAmount);
						LocalStruct.SpellCritAndOverAmount = tonumber(LocalStruct.SpellCritAndOverAmount);
						LocalStruct.SpellOverAmount = tonumber(LocalStruct.SpellOverAmount);
						LocalStruct.SpellOverAndAbsorbAmount = tonumber(LocalStruct.SpellOverAndAbsorbAmount);
						LocalStruct.SpellCritAndAbsorbAmount = tonumber(LocalStruct.SpellCritAndAbsorbAmount);
						LocalStruct.SpellAbsorbAmount = tonumber(LocalStruct.SpellAbsorbAmount);
						
						local AmountString = 
						StatBarColor.SpellHitAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellHitAmount).."/"..
						StatBarColor.SpellCritAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAmount).."/"..
						StatBarColor.SpellCritAndOverAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAndOverAmount).."/"..
						StatBarColor.SpellOverAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellOverAmount).."/"..
						StatBarColor.SpellOverAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellOverAndAbsorbAmount).."/"..
						StatBarColor.SpellCritAndAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellCritAndAbsorbAmount).."/"..
						StatBarColor.SpellAbsorbAmount..SpellTrackerBar_FormatAmountValueToString(LocalStruct.SpellAbsorbAmount);
						
						GuiBar.GUI.SpellSpellAmountLabel:SetText(AmountString);
					end
					
					if ( spellStruct.SpellAmountTotal ) then
						if ( spellStruct.SpellAmountTotal > 0 ) then
							local HitAmount = LocalStruct.SpellHitAmount*100/spellStruct.SpellAmountTotal;
							--local HitAndCritAmount = LocalStruct.SpellHitAndCritAmount*100/spellStruct.SpellAmountTotal;
							local CritAmount = LocalStruct.SpellCritAmount*100/spellStruct.SpellAmountTotal;
							local OverHitAndCritAmount = LocalStruct.SpellCritAndOverAmount*100/spellStruct.SpellAmountTotal;
							local OverHitAmount = LocalStruct.SpellOverAmount*100/spellStruct.SpellAmountTotal;
							local OverHitAmountAndAbsorb = LocalStruct.SpellOverAndAbsorbAmount*100/spellStruct.SpellAmountTotal;
							local CritAmountAndAbsorb = LocalStruct.SpellCritAndAbsorbAmount*100/spellStruct.SpellAmountTotal;
							
							GuiBar.GUI.StatusBarSpellHit:SetValue(HitAmount);
							GuiBar.GUI.StatusBarSpellCritAmountAndHit:SetValue(0);
							GuiBar.GUI.StatusBarSpellCritAmount:SetValue(CritAmount+HitAmount);
							GuiBar.GUI.StatusBarSpellOverHitAndCrit:SetValue(OverHitAndCritAmount+CritAmount+HitAmount);
							GuiBar.GUI.StatusBarSpellOverHit:SetValue(OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
							GuiBar.GUI.StatusBarSpellOverHitAndAbsorb:SetValue(OverHitAmountAndAbsorb+OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
							GuiBar.GUI.StatusBarSpellCritAndAbsorb:SetValue(CritAmountAndAbsorb+OverHitAmountAndAbsorb+OverHitAmount+OverHitAndCritAmount+CritAmount+HitAmount);
							GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(100);
						end
					else
						GuiBar.GUI.StatusBarSpellAbsorbAmount:SetValue(100);
					end
					
					GuiBar.VAR.Used = true;
				end
				idx = idx + 1;
			end
			SpellListToSort_Position = SpellListToSort_Position + 1;
		end
	end
	SpellTracker.CountBarToDisplay = #SpellTracker.SpellListToSort;
	
end
function SpellTracker:StringFiltering(strToFilter, pattern) -- 0.41 / pour separer les valeur du style : HitType > SpellName > SourceType > SourceReaction en list indx par int
	local lst = {};
	local idx = 0;
	while ( string.match(strToFilter, pattern) ) do
		strToFilter, it = string.match(strToFilter,pattern);
		lst[idx] = it;
		idx = idx + 1;
	end
	lst[idx] = strToFilter;
	-- on inverse
	local ret = {};
	for i=0,idx do
		ret[i] = lst[idx-i];
	end
	return ret;
end
function SpellTracker:StringFilteringInv(strToFilter, pattern) -- 0.41 / pour separer les valeur du style : HitType > SpellName > SourceType > SourceReaction en list indxe par nom
	local lst = {};
	local idx = 0;
	while ( string.match(strToFilter, pattern) ) do
		strToFilter, it = string.match(strToFilter,pattern);
		lst[it] = idx;
		idx = idx + 1;
	end
	lst[strToFilter] = idx;
	-- on inverse
	for k,v in pairs(lst) do
		lst[k] = idx-tonumber(v);
	end
    lst.count = idx; -- important car #lst d'une liste type dico renvoi rien du tout sauf si les index sont des number
	return lst;
end
function SpellTracker:WhatIsThisFlag(flag)
	if ( flag == nil )  then return; end
	if ( flag == 0 )  then return; end
    -- on sort quatre infos utile : TYPE CONTROL REACTION AFFILIATION
	local flagType, flagControl, flagReaction, flagAffiliation;

	if ( bit.band(flag, 0x00004000) > 0 ) then flagType = SpellTracker.CombatFlags[0x00004000]; end -- TYPE_OBJECT
	if ( bit.band(flag, 0x00002000) > 0 ) then flagType = SpellTracker.CombatFlags[0x00002000]; end -- TYPE_GUARDIAN
	if ( bit.band(flag, 0x00001000) > 0 ) then flagType = SpellTracker.CombatFlags[0x00001000]; end -- TYPE_PET
	if ( bit.band(flag, 0x00000800) > 0 ) then flagType = SpellTracker.CombatFlags[0x00000800]; end -- TYPE_NPC
	if ( bit.band(flag, 0x00000400) > 0 ) then flagType = SpellTracker.CombatFlags[0x00000400]; end -- TYPE_PLAYER
	
	if ( bit.band(flag, 0x00000200) > 0 ) then flagControl = SpellTracker.CombatFlags[0x00000200]; end -- CONTROL_NPC
	if ( bit.band(flag, 0x00000100) > 0 ) then flagControl = SpellTracker.CombatFlags[0x00000100]; end -- CONTROL_PLAYER
	
	if ( bit.band(flag, 0x00000040) > 0 ) then flagReaction = SpellTracker.CombatFlags[0x00000040]; end -- REACTION_HOSTILE
	if ( bit.band(flag, 0x00000020) > 0 ) then flagReaction = SpellTracker.CombatFlags[0x00000020]; end -- REACTION_NEUTRAL
	if ( bit.band(flag, 0x00000010) > 0 ) then flagReaction = SpellTracker.CombatFlags[0x00000010]; end -- REACTION_FRIENDLY
	
    if ( bit.band(flag, 0x00000008) > 0 ) then flagAffiliation = SpellTracker.CombatFlags[0x00000008]; end -- AFFILIATION_OUTSIDER
	if ( bit.band(flag, 0x00000004) > 0 ) then flagAffiliation = SpellTracker.CombatFlags[0x00000004]; end -- AFFILIATION_RAID
	if ( bit.band(flag, 0x00000002) > 0 ) then flagAffiliation = SpellTracker.CombatFlags[0x00000002]; end -- AFFILIATION_PARTY
	if ( bit.band(flag, 0x00000001) > 0 ) then flagAffiliation = SpellTracker.CombatFlags[0x00000001]; end -- AFFILIATION_MINE
    
    return flagType, flagControl, flagReaction, flagAffiliation;
end
function SpellTracker:WhatIsThisGuid(GUIDNumber)
	if ( GUIDNumber ~= nil and GUIDNumber ~= "" ) then
		local maskedB = tonumber(GUIDNumber:sub(5,5), 16) % 8; 
		local knownTypes = {[0]="player", [1]="object", [3]="mob", [4]="pet", [5]="vehicle"};
		local result = knownTypes[maskedB] or "Unknow";
		return result; 
    end
    return "Unknow";
end
function SpellTracker:COMBAT_LOG_EVENT_UNFILTERED(_,DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	local TargetType, GUID = nil, TargetName, SourceName, SourceType;
	
	if ( SpellTrackerDB.MenuDropDown_Target.It4.check == true ) then -- Raid Tracking Active
		RaidTrackingContinue = false;
		for k,v in pairs(SpellTracker.RaidLst) do
			if ( v ) then
				if ( GUIDSRC == v or GUIDDST == v ) then
					RaidTrackingContinue = true;
				end
			end
		end
		if ( RaidTrackingContinue == false ) then
			return nil;
		end
	end

	if ( SpellTrackerDB.MenuDropDown_Target.It5.check == true ) then -- Party Tracking Active
		PartyTrackingContinue = false;
		for k,v in pairs(SpellTracker.PartyLst) do
			if ( v ) then
				if ( GUIDSRC == v or GUIDDST == v ) then
					PartyTrackingContinue = true;
				end
			end
		end
		if ( PartyTrackingContinue == false ) then
			return nil;
		end
	end
	
	if ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == true ) then
		GUID = GUIDSRC;
		SourceType = SpellTracker:WhatIsThisGuid(GUIDSRC);
		SourceName = tostring(SRC);
		TargetType = SpellTracker:WhatIsThisGuid(GUIDDST);
		TargetName = tostring(DST);
	elseif ( SpellTrackerDB.CurrentPlayerTracked.Track_Attack_or_Attacked == false ) then
		GUID = GUIDDST;
		SourceType = SpellTracker:WhatIsThisGuid(GUIDDST);
		SourceName = tostring(DST);
		TargetType = SpellTracker:WhatIsThisGuid(GUIDSRC);
		TargetName = tostring(SRC);
	end
        
	if ( SpellTrackerDB.CurrentPlayerTracked.GUID ) then
		if ( GUID == SpellTrackerDB.CurrentPlayerTracked.GUID ) then
			local struct = SpellTracker:ReFormatEvent(DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...);
			if ( struct ) then
				SpellTracker:UpdateSpell(SourceType, SourceName, TargetType, TargetName, struct);
			end
		end
	else -- zone tracking enabled
		local struct = SpellTracker:ReFormatEvent(DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...);
		if ( struct ) then
			SpellTracker:UpdateSpell(SourceType, SourceName, TargetType, TargetName, struct);
		end
	end
end
function SpellTracker:ReFormatEvent(DATETIME, EVENTTYPE, hideCaster, GUIDSRC, SRC, SRCFLAG1, SRCFLAG2, GUIDDST, DST, DSTFLAG1, DSTFLAG2, ...)
	local Struct = nil;
	if ( EVENTTYPE == "SPELL_DAMAGE" ) then -- domage de sort
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL, Struct.RESISTED,	Struct.BLOCKED,	
		Struct.ABSORBED, Struct.CRITICAL, Struct.GLANCING, Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_DAMAGE" ) then -- dommage de sort en tick genre dot fievre de givre
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL, Struct.RESISTED, Struct.BLOCKED,	
		Struct.ABSORBED, Struct.CRITICAL, Struct.GLANCING, Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE SPELL TICK";
	elseif ( EVENTTYPE == "SWING_DAMAGE" ) then -- coup blanc
		Struct = {};
		Struct.AMOUNT, Struct.OVERKILL,
		Struct.SCHOOL, Struct.RESISTED,	Struct.BLOCKED,	
		Struct.ABSORBED, Struct.CRITICAL, Struct.GLANCING, Struct.CRUSHING = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.SPELLNAME = "COUP BLANC";
		Struct.HITTYPE = "DAMAGE";
		Struct.TYPE = "DAMAGE COUP BLANC";
	elseif ( EVENTTYPE == "SPELL_HEAL" ) then -- sort de soins
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERHEALING,
		Struct.ABSORBED, Struct.CRITICAL = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "HEAL";
		Struct.TYPE = "HEAL SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_HEAL" ) then -- tick de sort de soins
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.AMOUNT, Struct.OVERHEALING,
		Struct.ABSORBED, Struct.CRITICAL = ...;
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "HEAL";
		Struct.TYPE = "HEAL SPELL TICK";
	elseif ( EVENTTYPE == "SPELL_MISSED" ) then -- Sort Manqu ou partiellement manqu
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED SPELL";
	elseif ( EVENTTYPE == "SPELL_PERIODIC_MISSED" ) then -- Tick de Sort Manqu ou partiellement manqu
		Struct = {};
		Struct.SPELLID, Struct.SPELLNAME, Struct.SPELLSCHOOL, 
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED SPELL TICK";
	elseif ( EVENTTYPE == "SWING_MISSED" ) then -- coup blanc maqnu
		Struct = {};
		Struct.MISSEDTYPE, Struct.AMOUNT = ...; -- AMOUNT => montant du sort qui est absorb
		Struct.EVENTTYPE = EVENTTYPE;
		Struct.SPELLNAME = "COUP BLANC";
		Struct.HITTYPE = "MISSED";
		Struct.TYPE = "MISSED COUP BLANC";
	end
	if ( Struct ) then
		Struct.SRCFLAG1 = SRCFLAG1;
		Struct.DSTFLAG1 = DSTFLAG1;
	end
	return Struct;
end
function SpellTracker:GetAllSpellTexture(spellID) -- 0.40 / pour remplacer
	if ( spellID ) then
		name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spellID);
		return icon;
	end
	return nil;
end
function SpellTracker:GetSpellHyperlink(spellID) -- 0.41 /OK
	local name, rank = GetSpellInfo(spellID);
	return "Spell: |Hspell:" .. spellID .."|h|r|cff71d5ff[" .. name .. " " .. rank .. "]|r|h";
end
function SpellTracker:UpdateSpell(SourceType, SourceName, TargetType, TargetName, CombatLogStruct) -- TargetType = player or MOB / 
	-- voir http://www.wowwiki.com/API_COMBAT_LOG_EVENT
	local SpellIndexer;
	local SpellStruct = SpellTrackerDB.SPELLS;
			
	local flagTypeSrc, flagControlSrc, flagReactionSrc, flagAffiliationSrc = SpellTracker:WhatIsThisFlag(CombatLogStruct.SRCFLAG1);
	local flagTypeDst, flagControlDst, flagReactionDst, flagAffiliationDst = SpellTracker:WhatIsThisFlag(CombatLogStruct.DSTFLAG1);
	
	-- 0.41 => modification du comportement de l'indexer
	local currentKey = nil;
	local currentStruct = nil;
	local currentIT = nil;
	local res = nil;
	
	local FilterDataStruct = SpellTrackerDB.DataStruct;
	local CountFilterDataStructItem = #FilterDataStruct;
	for i=0,CountFilterDataStructItem do
		if ( SpellStruct == nil ) then break; end
		local it = FilterDataStruct[i];
		if ( it == "HitType" ) then -- Heal / Damage
			currentKey = tostring(CombatLogStruct.HITTYPE);
			currentIT = it;
			SpellStruct = SpellTracker:AddOrUpdateSpellsAmountsAndTicksStruct(SpellStruct, currentKey, currentIT, CombatLogStruct);
		elseif ( it == "SpellName" ) then -- Nom du sort
			currentKey = tostring(CombatLogStruct.SPELLNAME);
			currentIT = it;
			currentStruct = SpellStruct[currentKey];
			currentStruct = currentStruct or {};
			currentStruct.help = currentIT; --ca dit a quoi ca correspond
			-- on range les infos du sort
			currentStruct.SpellIconTex = ""; -- chemin de la texture du sort
			if ( currentStruct.SpellId ) then
				if ( currentStruct.SpellId ~= CombatLogStruct.SPELLID ) then
					currentStruct.TickSpellId = CombatLogStruct.SPELLID; -- id du tick
				end
			else
				currentStruct.SpellId = CombatLogStruct.SPELLID; -- id du sort
			end
			currentStruct.SpellIconTex = SpellTracker:GetAllSpellTexture(currentStruct.SpellId);
			--SpellStruct.Used = false; -- indique si la barre affiche des donnes actuellment ( remet  false pendant le reset de la barre )
			SpellStruct[currentKey] = currentStruct;
			SpellStruct = SpellStruct[currentKey];
		elseif ( it == "SourceType" ) then -- Type de source ( Mob, Player, Vehicle, Pet )
			currentKey = tostring(SourceType);
			currentIT = it;
			SpellStruct = SpellTracker:AddOrUpdateSpellsAmountsAndTicksStruct(SpellStruct, currentKey, currentIT, CombatLogStruct);
		elseif ( it == "SourceReaction" ) then -- raction de la source par rapport a mon perso
			currentKey = tostring(flagReactionSrc);
			currentIT = it;
			SpellStruct = SpellTracker:AddOrUpdateSpellsAmountsAndTicksStruct(SpellStruct, currentKey, currentIT, CombatLogStruct);
		elseif ( it == "SourceName" ) then -- Nom de la source
			currentKey = tostring(SourceName);
			currentIT = it;
			SpellStruct = SpellTracker:AddOrUpdateSpellsAmountsAndTicksStruct(SpellStruct, currentKey, currentIT, CombatLogStruct);
		elseif ( it == "TargetType" ) then -- Type de cible
			currentKey = tostring(TargetType);
			currentIT = it;
			SpellStruct = SpellTracker:AddOrUpdateSpellsAmountsAndTicksStruct(SpellStruct, currentKey, currentIT, CombatLogStruct);
		elseif ( it == "TargetReaction" ) then -- raction de la cible par rapport a mon perso
			currentKey = tostring(flagReactionDst);
			currentIT = it;
			SpellStruct = SpellTracker:AddOrUpdateSpellsAmountsAndTicksStruct(SpellStruct, currentKey, currentIT, CombatLogStruct);
		elseif ( it == "TargetName" ) then -- Nom de la cible
			currentKey = tostring(TargetName);
			currentIT = it;
			SpellStruct = SpellTracker:AddOrUpdateSpellsAmountsAndTicksStruct(SpellStruct, currentKey, currentIT, CombatLogStruct);
		end
	end
	
	if ( SpellStruct ) then -- on ajoute  la BD
	
		-- On maj la frame / 0.40 ralentissait toute l'interface lors des raids capitale
		if ( SpellTrackerFrame ) then
			if ( SpellTrackerFrame:IsVisible() ) then
				SpellTracker:UpdateFilteredSpellList(); -- recalcul
				SpellTracker:UpdateFrame(); -- maj
			end
		end
	end
end
function SpellTracker:AddOrUpdateSpellsAmountsAndTicksStruct(SpellStruct, currentKey, currentIT, CombatLogStruct) -- 0.41 / OK
	local currentStruct = SpellStruct[currentKey];
	currentStruct = currentStruct or {};
	currentStruct.help = currentIT; --ca dit a quoi ca correspond
	
	-- Amount / 0.40
	currentStruct.AmountLine = currentStruct.AmountLine or "0/0/0/0/0/0/0/0";
	currentStruct.SpellAmountTotal = currentStruct.SpellAmountTotal or 0; -- init ot not
	
	-- Ticks / 0.40
	currentStruct.TicksLine = currentStruct.TicksLine or "0/0/0/0/0/0/0/0/0";
	currentStruct.CountTicks = currentStruct.CountTicks or 0;
	
	-- Calcul
	CombatLogStruct.ABSORBED = CombatLogStruct.ABSORBED or 0;
	CombatLogStruct.OVERKILL = CombatLogStruct.OVERKILL or 0;
	CombatLogStruct.OVERHEALING = CombatLogStruct.OVERHEALING or 0;
	CombatLogStruct.CRITICAL = CombatLogStruct.CRITICAL or 0;
	if ( CombatLogStruct.OVERKILL < 0 ) then
		CombatLogStruct.OVERKILL = 0;
	end
	
	-- affectation des donnes selon le log de combat
	local SpellAmountTotal = 0;
	local SpellHitAmount = 0;
	local SpellCritAmount = 0;
	local SpellCritAndOverAmount = 0;
	local SpellOverAmount = 0;
	local SpellOverAndAbsorbAmount = 0;
	local SpellCritAndAbsorbAmount = 0;
	local SpellAbsorbAmount = 0;
	
	-- AMOUNT = 145000
	-- OVERKILL = 32000
	-- ce qui veut dure sur sur les 145000 seulement 32000 sont en exces
	-- donc AMOUNT vaut en fait AMOUNT - OVERKILL
	if ( CombatLogStruct.HITTYPE == "DAMAGE" ) then -- DAMAGE
		if ( CombatLogStruct.CRITICAL > 0 ) then -- crit
			SpellCritAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERKILL;
			SpellCritAndOverAmount = CombatLogStruct.OVERKILL;
			SpellCritAndAbsorbAmount = CombatLogStruct.ABSORBED;
		else -- normal
			SpellHitAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERKILL;
			SpellOverAmount = CombatLogStruct.OVERKILL;
			SpellAbsorbAmount = CombatLogStruct.ABSORBED;
		end
	elseif ( CombatLogStruct.HITTYPE == "HEAL" ) then -- HEAL
		if ( CombatLogStruct.CRITICAL > 0 ) then -- crit
			SpellCritAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERHEALING;
			SpellCritAndOverAmount = CombatLogStruct.OVERHEALING;
			SpellCritAndAbsorbAmount = CombatLogStruct.ABSORBED;
		else -- normal
			SpellHitAmount = CombatLogStruct.AMOUNT - CombatLogStruct.OVERHEALING;
			SpellOverAmount = CombatLogStruct.OVERHEALING;
			SpellAbsorbAmount = CombatLogStruct.ABSORBED;
		end
	elseif ( CombatLogStruct.HITTYPE == "MISSED" ) then -- MISSED
		if ( CombatLogStruct.MISSEDTYPE == "ABSORB" ) then
			SpellAbsorbAmount = CombatLogStruct.AMOUNT or 0; -- au cas ou CombatLogStruct.AMOUNT vaudrait nil
		end
	end
	
	-- On recup les donnes actuelle / 0.40
	local LocalStruct = {};
	LocalStruct.SpellHitAmount, LocalStruct.SpellHitAndCritAmount, 
		LocalStruct.SpellCritAmount, LocalStruct.SpellCritAndOverAmount, LocalStruct.SpellOverAmount, 
		LocalStruct.SpellOverAndAbsorbAmount, LocalStruct.SpellCritAndAbsorbAmount, LocalStruct.SpellAbsorbAmount
		= string.match(currentStruct.AmountLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");
	LocalStruct.SpellHitAmount = tonumber(LocalStruct.SpellHitAmount);
	LocalStruct.SpellHitAndCritAmount = tonumber(LocalStruct.SpellHitAndCritAmount);
	LocalStruct.SpellCritAmount = tonumber(LocalStruct.SpellCritAmount);
	LocalStruct.SpellCritAndOverAmount = tonumber(LocalStruct.SpellCritAndOverAmount);
	LocalStruct.SpellOverAmount = tonumber(LocalStruct.SpellOverAmount);
	LocalStruct.SpellOverAndAbsorbAmount = tonumber(LocalStruct.SpellOverAndAbsorbAmount);
	LocalStruct.SpellCritAndAbsorbAmount = tonumber(LocalStruct.SpellCritAndAbsorbAmount);
	LocalStruct.SpellAbsorbAmount = tonumber(LocalStruct.SpellAbsorbAmount);
					
	LocalStruct.CountSpellHit, LocalStruct.CountSpellMissed, LocalStruct.CountSpellImmune, 
		LocalStruct.CountSpellAbsorb, LocalStruct.CountSpellOver, LocalStruct.CountSpellCrit, LocalStruct.CountSpellCritAndOver, 
		LocalStruct.CountSpellCritAndAbsorb, LocalStruct.CountSpellOverAndAbsorb
		= string.match(currentStruct.TicksLine, "(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)/(%S+)");
	LocalStruct.CountSpellHit = tonumber(LocalStruct.CountSpellHit);
	LocalStruct.CountSpellMissed = tonumber(LocalStruct.CountSpellMissed);
	LocalStruct.CountSpellImmune = tonumber(LocalStruct.CountSpellImmune);
	LocalStruct.CountSpellAbsorb = tonumber(LocalStruct.CountSpellAbsorb);
	LocalStruct.CountSpellOver = tonumber(LocalStruct.CountSpellOver);
	LocalStruct.CountSpellCrit = tonumber(LocalStruct.CountSpellCrit);
	LocalStruct.CountSpellCritAndOver = tonumber(LocalStruct.CountSpellCritAndOver);
	LocalStruct.CountSpellCritAndAbsorb = tonumber(LocalStruct.CountSpellCritAndAbsorb);
	LocalStruct.CountSpellOverAndAbsorb = tonumber(LocalStruct.CountSpellOverAndAbsorb);
	
	-- Montants
	LocalStruct.SpellHitAmount = (LocalStruct.SpellHitAmount) + SpellHitAmount;
	LocalStruct.SpellCritAmount = (LocalStruct.SpellCritAmount) + SpellCritAmount;
	LocalStruct.SpellCritAndOverAmount = (LocalStruct.SpellCritAndOverAmount) + SpellCritAndOverAmount;
	LocalStruct.SpellOverAmount = (LocalStruct.SpellOverAmount) + SpellOverAmount;
	LocalStruct.SpellCritAndAbsorbAmount = (LocalStruct.SpellCritAndAbsorbAmount) + SpellCritAndAbsorbAmount;
	LocalStruct.SpellOverAndAbsorbAmount = (LocalStruct.SpellOverAndAbsorbAmount) + SpellOverAndAbsorbAmount;
	LocalStruct.SpellAbsorbAmount = (LocalStruct.SpellAbsorbAmount) + SpellAbsorbAmount;
	
	local CurrentSpellTotalAmount = 
		SpellCritAmount + SpellCritAndOverAmount + SpellCritAndAbsorbAmount + -- crit
		SpellHitAmount + SpellOverAmount + SpellAbsorbAmount; -- hit
		
	if ( CurrentSpellTotalAmount > 0 ) then -- on ajoute  la BD
		currentStruct.SpellAmountTotal = currentStruct.SpellAmountTotal + CurrentSpellTotalAmount;
		
		-- Ticks
		if ( SpellHitAmount > 0 ) then LocalStruct.CountSpellHit = LocalStruct.CountSpellHit + 1; end
		if ( SpellCritAmount > 0 ) then LocalStruct.CountSpellCrit = LocalStruct.CountSpellCrit + 1; end
		if ( SpellCritAndOverAmount > 0 ) then LocalStruct.CountSpellCritAndOver = LocalStruct.CountSpellCritAndOver + 1; end
		if ( SpellOverAmount > 0 ) then LocalStruct.CountSpellOver = LocalStruct.CountSpellOver + 1; end
		if ( SpellCritAndAbsorbAmount > 0 ) then LocalStruct.CountSpellCritAndAbsorb = LocalStruct.CountSpellCritAndAbsorb + 1; end
		if ( SpellOverAndAbsorbAmount > 0 ) then LocalStruct.CountSpellOverAndAbsorb = LocalStruct.CountSpellOverAndAbsorb + 1; end
		if ( SpellAbsorbAmount > 0 ) then LocalStruct.CountSpellAbsorb = LocalStruct.CountSpellAbsorb + 1; end
		
		-- 1 tick de plus
		currentStruct.CountTicks = currentStruct.CountTicks + 1;
		
		-- On retransforme les donnes en deux lignes / 0.40
		currentStruct.AmountLine = LocalStruct.SpellHitAmount.."/"..LocalStruct.SpellHitAndCritAmount.."/"..
			LocalStruct.SpellCritAmount.."/"..LocalStruct.SpellCritAndOverAmount.."/"..
			LocalStruct.SpellOverAmount.."/"..LocalStruct.SpellOverAndAbsorbAmount.."/"..LocalStruct.SpellCritAndAbsorbAmount.."/"..
			LocalStruct.SpellAbsorbAmount;
			
		currentStruct.TicksLine = LocalStruct.CountSpellHit.."/"..LocalStruct.CountSpellMissed.."/"..
			LocalStruct.CountSpellImmune.."/"..LocalStruct.CountSpellAbsorb.."/"..LocalStruct.CountSpellOver.."/"..
			LocalStruct.CountSpellCrit.."/"..LocalStruct.CountSpellCritAndOver.."/"..LocalStruct.CountSpellCritAndAbsorb.."/"..
			LocalStruct.CountSpellOverAndAbsorb;	
	
		SpellStruct[currentKey] = currentStruct;
		
		SpellTracker:CalcEventsPerSec();
		
		return currentStruct;
	end
	return nil;
end
-- COMBAT_LOG_EVENT_UNFILTERED => Extracted form www.WowWiki.com/API_COMBAT_LOG_EVENT
--[[
1st Param 	2nd Param 	3rd Param 	4th Param 	5th Param 	6th Param 	7th Param 		8th Param 	9th Param 	10th Param 	11th Param
timestamp 	event 		hideCaster 	sourceGUID 	sourceName 	sourceFlags sourceFlags2 	destGUID 	destName 	destFlags 	destFlags2

prefix 			1st Parameter (12th) 	2nd Paramater (13th) 	3rd Parameter (14th)
SWING
RANGE 			spellId 				spellName 				spellSchool
SPELL 			spellId 				spellName 				spellSchool
SPELL_PERIODIC 	spellId 				spellName 				spellSchool
SPELL_BUILDING 	spellId 				spellName 				spellSchool
ENVIRONMENTAL 	environmentalType

Suffix 				1st Param (15th)	2nd Param (16th)	3rd Param (17th)	4th Param (18th)	5th Param (19th)	6th Param (20th)	7th Param (21th)	8th Param (22th)	9th Param (23th)
_DAMAGE 			amount 				overkill 			school 				resisted 			blocked 			absorbed 			critical (1 or nil) glancing (1 or nil) crushing (1 or nil)
_MISSED 			missType			isOffHand 			amountMissed*
_HEAL 				amount 				overhealing 		absorbed 			critical
_ENERGIZE 			amount 				powerType
_DRAIN 				amount 				powerType 			extraAmount
_LEECH 				amount 				powerType 			extraAmount
_INTERRUPT 			extraSpellID 		extraSpellName 		extraSchool
_DISPEL 			extraSpellID 		extraSpellName 		extraSchool 		auraType
_DISPEL_FAILED 		extraSpellID 		extraSpellName 		extraSchool
_STOLEN 			extraSpellID 		extraSpellName 		extraSchool 		auraType
_EXTRA_ATTACKS 		amount
_AURA_APPLIED 		auraType
_AURA_REMOVED 		auraType
_AURA_APPLIED_DOSE 	auraType 			amount
_AURA_REMOVED_DOSE 	auraType 			amount
_AURA_REFRESH 		auraType
_AURA_BROKEN 		auraType
_AURA_BROKEN_SPELL 	extraSpellID 		extraSpellName 		extraSchool 		auraType
_CAST_START
_CAST_SUCCESS
_CAST_FAILED 		failedType
_INSTAKILL
_DURABILITY_DAMAGE
_DURABILITY_DAMAGE_ALL
_CREATE
_SUMMON
_RESURRECT

Event 					Prefix to use 		Suffix to use
DAMAGE_SHIELD 			SPELL 				_DAMAGE
DAMAGE_SPLIT 			SPELL 				_DAMAGE
DAMAGE_SHIELD_MISSED 	SPELL 				_MISSED

Event 				1st Param 	2nd Param 	3rd Param
ENCHANT_APPLIED 	spellName 	itemID 		itemName
ENCHANT_REMOVED 	spellName 	itemID 		itemName
PARTY_KILL
UNIT_DIED
UNIT_DESTROYED

Event Prefix Description
SPELL_
Spell is the prefix for most effects even if the spell is a DoT or channeled. IE when the spell begins to be cast, SPELL_CAST_START is
fired and not SPELL_PERIODIC_CAST_START. This is the same with _MISS, _FAILED, etc.

SPELL_PERIODIC
Spell_PERIODIC Only the effects that are periodic start with this PREFIX. IE: Successfully casting a DoT only happens once therefor
even though the spell is periodic use the SPELL_ prefix. However, the damage is periodic so it will start with SPELL_PERIODIC_. 90%
of the time you will only care about _DAMAGE or _HEAL.
SPELL_BUILDING SPELL_BUILDING New in WotLK, assumed to be damage that can affect destructable buildings.
ENVIRONMENTAL sourceGUID = "0x0000000000000000", sourceName = nil

Suffixes
Event Prefix Description
_DAMAGE Triggered on damage to health. Nothing Special. (overkill returns a number greater than or equal to zero)

_MISSED
Triggered When Effect isn't applied but mana/energy is used IE: ABSORB BLOCK DEFLECT DODGE EVADE IMMUNE MISS
PARRY REFLECT RESIST

_HEAL Triggered when a unit is healed

_ENERGIZE
Any effect that restores energy/mana. Spell/trinket/item set bonuses can trigger this event. IE: Vampiric Touch, or Mark of
Defiance (Trinket)

_DRAIN Same as _ENERGIZE but this time you are losing energy/mana. Caused by enemies.

_LEECH Same as _DRAIN, but the source unit will simultaneously receive the same kind of energy (specified in extraAmount)

_INTERRUPT Spellcasting being interrupted by an ability such as Kick or Pummel.

_DISPEL A buff or debuff being actively dispelled by a spell like Remove Curse or Dispel Magic.

_DISPEL_FAILED A failed attempt to dispel a buff or debuff, most likely due to immunity.

_AURA_STOLEN A buff being transferred from the destination unit to the source unit (i.e. mages' Spellsteal).

_EXTRA_ATTACKS
Unit gains extra melee attacks due to an ability (like Sword Specialization or Windfury). These attacks usually happen in
brief succession 100-200ms following this event.

_AURA_APPLIED
Triggered When Buffs/Debuffs are Applied. Note: This event doesn't fire if a debuff is applied twice without being removed.
IE: casting Vampiric Embrace twice in a row only triggers this event once. This can make it difficult to track whether a debuff
was successfully reapplied to the target. However, for instant cast spells, SPELL_CAST_SUCCESS can be used.

_AURA_REMOVED Triggered When Buffs/Debuffs expire.

_AURA_APPLIED_DOSE
Triggered by stacking Debuffs if the debuff is already applied to a target. IE: If you cast Mind Flay twice it causes 2 doses of
shadow vunerability, the first time it will trigger, SPELL_AURA_APPLIED (arg10 = shadow vulnerability), and
SPELL_AURA_APPLIED_DOSE (arg10 = shadow vunerability) the second. The last argument reflects the new number of
doses on the unit.

_AURA_REMOVED_DOSE The opposite of _AURA_APPLIED_DOSE, reducing the amount of doses on a buff/debuff on the unit.

_AURA_REFRESH Resets the expiration timer of a buff/debuff on the unit.

_AURA_BROKEN A buff or debuff is being removed by melee damage

_AURA_BROKEN_SPELL A buff or debuff is being removed by spell damage (specified in extraSpell...)

_CAST_START
Triggered when a spell begins casting. Instant Cast and channeled spells don't invoke this event. They trigger

_CAST_SUCCESS, _MISS instead.

_CAST_SUCCESS
Triggered when channeled spells begin or when instant cast spells are cast. This (obviously) isn't triggered when this spell
misses. On a miss SPELL_MISS will be triggered instead. Also, spells that invoke _CAST_START don't trigger this event
when they are done casting. Use _SPELL_MISS or _SPELL_DAMAGE or _SPELL_AURA_APPLIED to see when they were
cast

_CAST_FAILED
If the cast fails before it starts (IE invalid target), then _CAST_START never triggers. However it is possible for a cast to fail
after beginning. (IE you jump, move, hit escape etc.)

_INSTAKILL Immediately kills the destination unit (usually happens when warlocks sacrifice their minions).

_DURABILITY_DAMAGE

_DURABILITY_DAMAGE_ALL

_CREATE Creates an object (as opposed to an NPC who are 'summoned') like a hunter's trap or a mage's portal.

_SUMMON Summmons an NPC such as a pet or totem.

Special Events
Event Description
UNIT_DIED destGUID and destName refer to the unit that died.
PARTY_KILL includes both sourceGUID and destGUID, but only reports for you (not in a party) or your other 4 party members (not raid members)
]]--